########################################################################
package Fireball ;
require Exporter ;
our @ISA = qw( Exporter ) ;
our @EXPORT = qw( titleWithHelp
startPage
FBstart_html
FBheader
timestamp
@dayStrings
@monthStrings
@nmeaMessages
%waasStrings
IsRpmFile
underWarranty
RpmVerify
saveFtpSetup
getFtpSetup
getGuiSecurity
updateGuiSecurity
makepw
updateGuiAccounts
getGuiAccounts
getAntennaInfo
getAntennaSetup
updateAntennaSetup
getEthernetSetup
updateEthernetSetup
getSessionData
updateSessionData
EnaDisSession
getPortSetup
saveGpssdConfig
saveMetConfig
savePppConfig
sendBinaryFile
getRefStationData
updateRefStationData
getNtpServers
saveNtpServers
getIoStatus
getAutoDeleteControls
saveAutoDeleteControls
getPoolStatus
installConfigFile
newStingerConfig
getHttpSetup
saveHttpSetup
getIptablesSetup
saveIptablesSetup
getAdvertiseControls
saveAdvertiseControls
getPppDialoutControls
savePppDialoutControls
getVoltages
getVsleep
saveVsleep
MakeConfigFile
getAutoRebootLimit
saveAutoRebootLimit
autoRebootReset
) ;
use CGI qw/:standard/ ;
use IO::Socket;
@dayStrings = ("Sun","Mon","Tue","Wed","Thu","Fri","Sat") ;
@monthStrings = ("Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec") ;
%waasStrings = (
120 => 'ESTB-AOR-E',
121 => 'prn121',
122 => 'WAAS-AOR-W',
123 => 'prn123',
124 => 'EGNOS-ARTEMIS',
125 => 'prn125',
126 => 'EGNOS-IND-W',
127 => 'GAGAN-127',
128 => 'GAGAN-128',
129 => 'MSAS-1',
130 => 'prn130',
131 => 'EGNOS-IOR',
132 => 'prn132',
133 => 'prn133',
134 => 'WAAS-POR',
135 => 'WAAS-GALAXY-XV',
136 => 'prn136',
137 => 'MSAS-2',
138 => 'WAAS-ANIK-F1R'
) ;
@nmeaMessages = ( 'GGA','GLL','GRS','GSA','ZDA','GST', 'GSV'
) ;
sub FBheader
{
print CGI::header(-expires=>"-10y") ;
}
sub FBstart_html
{
print CGI::start_html(
-bgcolor=>'#fff5e4',
-title=>$_[0],
-head=>meta( {-http_equiv=>'Content-Type',
-content=>'text/html; charset=iso-8859-1'
}
)
.meta( {-name=>'copyright',
-content=>
'Copyright(c) 2003 Trimble Navigation Ltd.'
}
)
), "\n" ;
}
sub startPage
{
FBheader() ;
FBstart_html( $_[0] ) ;
}
sub titleWithHelp
{
startPage( $_[0] ) ;
print table( {width=>"100%"},
Tr(
td( h2( $_[0] ) ),
$_[1]
? td( {align=>'right'},
a( {href=>"" ,
onMouseOver=>'document.images[0].src  = "/images/helpRollover.gif"',
onMouseOut =>'document.images[0].src  = "/images/help.gif"',
onClick=>
"top.showHelp('$_[1]') ;
return false"},
img( { src=>"/images/help.gif",
border=>"0",
}
)
)
)
: td( '&nbsp;' )
)
);
}
sub timestamp
{
my $time=time() ;
my ($s,$m,$h,$md,$mon,$y,$wday) = gmtime($time) ;
my $gpsweek = int( ($time - 315964800)/604800 ) ;
sprintf( "<b>UTC Date & Time: </b>"
."%d %s %d - %s of GPS Week %d - %02d:%02d:%02d",
$md, $monthStrings[$mon], $y+1900,
$dayStrings[$wday], $gpsweek, $h,$m, $s ) ;
}
sub RpmVerify
{
my $filePath = $_[0] ;
my $verbose = 1 ;
$verbose = $_[1] if ($_[1]) ;
my $fileSize = (-s $filePath) ;
my $availSpace = (split " ", qx( df /var/tmp ))[10] * 1024 ;
if ( ($fileSize+100000) >  $availSpace )
{
if ($verbose)
{
print '<br />Insufficient file space in /var/tmp.' ;
print
"<br />RPM size : $fileSize<br />Available Space : $availSpace<br />" ;
}
for my $f ( sort {(-s $b) <=> (-s $a)} glob( '/var/log/*.[1-9]' ) )
{
print "Reclaiming log file $f : ", (-s $f), br() if ($verbose) ;
system( "/usr/bin/logger -t FirmwareVerify 'Reclaiming $f'" ) ;
system( "/usr/bin/sudo rm $f" ) ;
$availSpace = (split " ", qx( df /var/tmp ))[10] * 1024 ;
if ( ($fileSize+100000) <  $availSpace )
{
print "Available Space up to $availSpace<p>" if ($verbose) ;
goto TEST ;
}
}
for my $f ( sort {(-s $b) <=> (-s $a)} glob( '/var/tmp/*' ) )
{
print "Reclaiming log file $f : ", (-s $f), br() if ($verbose) ;
system( "/usr/bin/logger -t FirmwareVerify 'Reclaiming $f'" ) ;
system( "/usr/bin/sudo rm $f" ) ;
$availSpace = (split " ", qx( df /var/tmp ))[10] * 1024 ;
if ( ($fileSize+100000) <  $availSpace )
{
print "Available Space up to $availSpace<p>" if ($verbose) ;
goto TEST ;
}
}
for my $f ( sort {(-s $b) <=> (-s $a)} glob( '/var/log/*' ) )
{
print "Pruning log file $f : ", (-s $f), br() if ($verbose) ;
system( "/usr/bin/logger -t FirmwareVerify 'Pruning $f'" ) ;
open F, '>/tmp/emptyFile' ;
print F qx( /bin/date ) ;
print F "Log file pruned during firmware verify.\n" ;
close( F ) ;
system( "/usr/bin/sudo cp /tmp/emptyFile $f" ) ;
unlink( "/tmp/emptyFile" ) ;
$availSpace = (split " ", qx( df /var/tmp ))[10] * 1024 ;
if ( ($fileSize+100000) <  $availSpace )
{
print "Available Space up to $availSpace<p>" if ($verbose) ;
goto TEST ;
}
}
return 'Insufficient /var/tmp space' ;
}
TEST:
my $testResults = qx( /usr/lib/rpm/rpmk -K $filePath 2>&1 ) ;
if ($testResults =~ 'md5 OK')
{
return '' ;
}
else
{
return $testResults ;
}
}
sub IsRpmFile
{
my $filepath = $_[0] ;
my ( $c1,$c2, $c3, $c4 ) ;
if (open( RPMFILE, $filepath ) )
{
$c0 = ord( getc( RPMFILE ) ) ;
$c1 = ord( getc( RPMFILE ) ) ;
$c2 = ord( getc( RPMFILE ) ) ;
$c3 = ord( getc( RPMFILE ) ) ;
close( RPMFILE ) ;
}
return ( $c0 == 0xed
&& $c1 == 0xab
&& $c2 == 0xee
&& $c3 == 0xdb
) ;
}
sub underWarranty
{
my $filepath = $_[0] ;
my $verbose  = $_[1] ;
my $descriptionReference = $_[2] ;
my $warrantyDate = qx(/usr/bin/sudo /usr/local/fireball/warranty -w) ;
$warrantyDate = (split("[ :]+",$warrantyDate))[2] ;
if ($warrantyDate != 0)
{
my ($month,$day,$year) = ($warrantyDate =~ /(..)(..)(....)/) ;
$warrantyDate = sprintf( "%04d/%02d/%02d", $year,$month,$day ) ;
}
else
{
$warrantyDate = '2000/01/01' ;
}
my $description =
qx( /usr/lib/rpm/rpmq -q -p $filepath --qf '%{DESCRIPTION}') ;
if ($descriptionReference)
{
$$descriptionReference = $description ;
}
my $firmwareDate = ($description =~ m/.*Firmware Date\s+(\S+)/ )[0] ;
my ($year,$month,$day) = ($firmwareDate =~ m|(.+)/(.+)/(.+)|) ;
$firmwareDate = sprintf( "%04d/%02d/%02d", $year,$month,$day ) ;
if ($verbose)
{
print table( Tr( td( {align=>'right'},
"Warranty Expiration Date:"
),
td( $warrantyDate )
),
Tr( td( {align=>'right'}, "Firmware Date:" ),
td( $firmwareDate )
),
) ;
}
return ( $warrantyDate ge $firmwareDate
|| $description =~ m/Expected Installation Time.*:.*\./
) ;
}
sub getFtpSetup
{
my $refHash = $_[0] ;
my %ftpSetup ;
$ftpSetup{'ftpEnabled'} = 'yes' ;
$ftpSetup{'standardPort'} = 'yes' ;
$ftpSetup{'alternatePort'} = 8021 ;
$ftpSetup{'anon'} = 'enabled' ;
$ftpSetup{'named'} = 'disabled' ;
$ftpSetup{'admin'} = 'disabled' ;
$ftpSetup{'namedPassword'} = '' ;
$ftpSetup{'adminPassword'} = '' ;
if ( open( FTPCONFIG, '/etc/sysconfig/ftp.conf' ) )
{
while (<FTPCONFIG>)
{
my ($key, $value) = split ;
$ftpSetup{$key} = $value ;
}
close( FTPCONFIG ) ;
}
%{$refHash} = %ftpSetup ;
}
sub saveFtpSetup
{
my %ftpSetup = %{$_[0]} ;
open( FTPSETUP, '>/tmp/ftp.conf.new' ) ;
print FTPSETUP
"ftpEnabled $ftpSetup{'ftpEnabled'}\n",
"standardPort $ftpSetup{'standardPort'}\n",
"alternatePort $ftpSetup{'alternatePort'}\n",
"anon $ftpSetup{'anon'}\n",
"named $ftpSetup{'named'}\n",
"admin $ftpSetup{'admin'}\n",
"namedPassword $ftpSetup{'namedPassword'}\n",
"adminPassword $ftpSetup{'adminPassword'}\n"
;
close( FTPSETUP ) ;
installConfigFile( 'ftp.conf.new', 'ftp.conf' ) ;
if ( -r '/var/run/ftpd.pid' )
{
my $pid = qx( cat /var/run/ftpd.pid ) ;
system( "/usr/bin/sudo /bin/kill $pid" ) ;
}
}
sub getGuiSecurity
{
my $restrictions = $_[0] ;
my @levels = ( 'sysadmin', 'gpsadmin', 'fileaccess' ) ;
foreach my $r (@levels)
{
${$restrictions}{ $r } = 0 ;
if (open( HTACCESS, "/etc/sysconfig/htaccess.$r" ) )
{
while (<HTACCESS>)
{
if ( $_ =~ '^require ')
{
${$restrictions}{ $r } = 1 ;
}
}
close HTACCESS ;
}
}
}
sub updateGuiSecurity
{
my $newRestrictions = $_[0] ;
my $changeMade = 0 ;
my %oldRestrictions ;
getGuiSecurity( \%oldRestrictions ) ;
my @levels = ( 'sysadmin', 'gpsadmin', 'fileaccess' ) ;
foreach my $r (@levels)
{
if (${$newRestrictions}{$r} != $oldRestrictions{$r})
{
my $cfgFile = "htaccess.$r" ;
open( HTACCESS, ">/tmp/$cfgFile.new" ) ;
print HTACCESS << "EOF" ;
AuthType Basic
AuthUserFile /etc/sysconfig/htpasswd
AuthGroupFile /etc/sysconfig/htgroups
EOF
print HTACCESS "AuthName " ;
if ($r eq 'sysadmin')     { print HTACCESS "SysAdmin\n" }
elsif ($r eq 'gpsadmin')  { print HTACCESS "GpsAdmin\n" }
else                      { print HTACCESS "FileAccess\n" }
print HTACCESS "require group $r\n" if (${$newRestrictions}{$r}) ;
close HTACCESS ;
installConfigFile( "$cfgFile.new", "$cfgFile" ) ;
}
}
return $changeMade ;
}
sub getGuiAccounts
{
my $accountHashReference = $_[0] ;
my %accounts ;
if ( open( HTPASSWD, '/etc/sysconfig/htpasswd' ) )
{
while (<HTPASSWD>)
{
chomp ;
my ($name,$pw) = split ':' ;
$accounts{$name}{'password'} = $pw ;
$accounts{$name}{'sysadmin'} = 0 ;
$accounts{$name}{'gpsadmin'} = 0 ;
$accounts{$name}{'fileaccess'} = 0 ;
}
close( HTPASSWD ) ;
}
if ( open( HTGROUPS, '/etc/sysconfig/htgroups' ) )
{
while (<HTGROUPS>)
{
chomp ;
if ( $_ =~ '^sysadmin:')
{
my @names = split / / ;
shift( @names ) ;
for my $name (@names)
{
$accounts{$name}{'sysadmin'} = 1 ;
}
}
elsif ($_ =~ '^gpsadmin:')
{
my @names = split / / ;
shift( @names ) ;
for my $name (@names)
{
$accounts{$name}{'gpsadmin'} = 1 ;
}
}
elsif ($_ =~ '^fileaccess:')
{
my @names = split / / ;
shift( @names ) ;
for my $name (@names)
{
$accounts{$name}{'fileaccess'} = 1 ;
}
}
}
close( HTGROUPS ) ;
}
%{$accountHashReference} = %accounts ;
}
sub updateGuiAccounts
{
my $accountsReference = $_[0] ;
open( HTPASSWD, ">/tmp/htpasswd.new" ) ;
foreach ( sort keys %{$accountsReference} )
{
print HTPASSWD "$_:${$accountsReference}{$_}{'password'}\n" ;
}
close HTPASSWD ;
open( HTGROUPS, ">/tmp/htgroups.new" ) ;
for my $group ( 'sysadmin', 'gpsadmin', 'fileaccess' )
{
print HTGROUPS "$group:" ;
foreach ( sort keys %{$accountsReference} )
{
print HTGROUPS " $_" if ${$accountsReference}{$_}{$group} ;
}
print HTGROUPS "\n" ;
}
close HTGROUPS ;
installConfigFile( "htpasswd.new", "htpasswd" ) ;
installConfigFile( "htgroups.new", "htgroups" ) ;
}
sub makepw
{
my $seed=join '',
('.','/','0'..'9','A'..'Z','a'..'z')[rand 64, rand 64];
return crypt( $_[0], $seed ) ;
}
sub getAntennaInfo
{
my $refToHash = $_[0] ;
my %antInfo ;
open( ANTINFO, '/usr/local/fireball/antennaModel.config' ) ;
while ( <ANTINFO> )
{
next if (m/^\s*$/) ;
if (m/^AntName:\s*(.*)$/)
{
my $name = $1 ;
$name =~ s/\s+$// ;
my $antType = <ANTINFO> ;
$antType =~ s/^.*:\s*(\d+)\s*$/$1/ ;
$antInfo{$antType}{'name'} = $name ;
my $NGS = <ANTINFO> ;
$NGS =~ s/^.*:\s*(.*)$/$1/ ;
chomp $NGS ;
$antInfo{$antType}{'ngs'} = $NGS ;
my $charCode = <ANTINFO> ;
$charCode =~ s/^.*:\s*(.*)$/$1/ ;
chomp $charCode ;
$antInfo{$antType}{'code'} = $charCode ;
my $RinexMethod = <ANTINFO> ;
my $RinexOffset = <ANTINFO> ;
my $methodCount = <ANTINFO> ;
$methodCount =~ s/^.*:\s*(\d+)\s*$/$1/ ;
++$methodCount ;
$antInfo{$antType}{'methodCount'} = $methodCount ;
my $defMethod = <ANTINFO> ;
chomp $defMethod ;
$defMethod =~ s/^.*\[(\d+)\].*/$1/ ;
$antInfo{$antType}{'defMethod'} = $defMethod+1 ;
for (my $m = 0 ; $m < $methodCount ; ++$m)
{
my $method = <ANTINFO> ;
$method =~ s/^.*:\s*(.*)$/$1/ ;
chomp $method ;
$method =~ s/\s+$// ;
$antInfo{$antType}{'methods'}[$m] = $method ;
$_ = <ANTINFO> ;
}
}
}
close( ANTINFO ) ;
%{$refToHash} = %antInfo ;
}
sub getAntennaSetup
{
my $refToHash = $_[0] ;
my %antSetup ;
$antSetup{'domeSerial'} = '' ;
open( REFCONF, '/usr/local/fireball/sysinfo -p ref_stn |' ) ;
while (<REFCONF>)
{
if (m/^\s*AntType\s*:\s*(\S+)\s*$/)
{
$antSetup{'type'} = $1 ;
}
if (m/^\s*AntMethod\s*:\s*(\S+)\s*$/)
{
$antSetup{'method'} = $1+1 ;
}
if (m/^\s*AntSerial\s*:\s*(\S+)\s*$/)
{
$antSetup{'serial'} = $1 ;
}
if (m/^\s*AntTextSerial\s*:\s*(.*)\s*$/)
{
$antSetup{'textSerial'} = $1 ;
}
if (m/^\s*AntDomeSerial\s*:\s*(.*)\s*$/)
{
$antSetup{'domeSerial'} = $1 ;
}
if (m/^\s*AntHeight\s*:\s*(\S+)\s*$/)
{
$antSetup{'height'} = sprintf( "%.3f", $1 ) ;
}
}
close( REFCONF ) ;
%{$refToHash} = %antSetup ;
}
sub updateAntennaSetup
{
my ( $serial,
$type,
$height,
$method,
$name,
$textSerial,
$domeSerial
) = @_ ;
open( NEWCONF, '>/tmp/ref_stn.config.new' ) ;
if (open( OLDCONF, '/etc/sysconfig/ref_stn.config' ))
{
while (<OLDCONF>)
{
next if ( m/^\s*(AntSerial|AntType|AntName|AntMethod|AntHeight|AntTextSerial|AntDomeSerial)\s*:/ ) ;
print NEWCONF $_ ;
}
}
close( OLDCONF ) ;
printf NEWCONF "AntSerial:     %s\n", $serial ;
printf NEWCONF "AntTextSerial: %s\n", $textSerial ;
printf NEWCONF "AntDomeSerial: %s\n", $domeSerial ;
printf NEWCONF "AntType:       %s\n", $type ;
printf NEWCONF "AntName:       %s\n", $name ;
printf NEWCONF "AntHeight:     %s\n", $height ;
printf NEWCONF "AntMethod:     %s\n", ($method - 1) ;
close( NEWCONF ) ;
installConfigFile( "ref_stn.config.new", "ref_stn.config" ) ;
system( 'sudo /usr/local/fireball/sysinfo -m' ) ;
}
sub getEthernetSetup
{
my $hashRef = $_[0] ;
my %ethernetSetup ;
$ethernetSetup{'ipmode'} =
(split( ' ',
qx| grep '^ *iface  *eth0' /etc/sysconfig/interfaces|
)
)[3] ;
my $macAddress = qx( /usr/local/fireball/getmac ) ;
chomp $macAddress ;
substr( $macAddress, 10, 0 ) = ':' ;
substr( $macAddress,  8, 0 ) = ':' ;
substr( $macAddress,  6, 0 ) = ':' ;
substr( $macAddress,  4, 0 ) = ':' ;
substr( $macAddress,  2, 0 ) = ':' ;
$ethernetSetup{'mac'} = $macAddress ;
my $ipAddress = '0.0.0.0' ;
my $netMask = '255.255.255.0' ;
my @results=split( ' ',
qx( /sbin/ifconfig eth0 | grep 'inet addr:' )
) ;
if (@results)
{
$ipAddress  = (split( ':', $results[1] ))[1] ;
$netMask  = (split( ':', $results[3] ))[1] ;
}
elsif ($ethernetSetup{'ipmode'} eq 'static')
{
$ipAddress =
(split( ' ', qx(grep address /etc/sysconfig/interfaces) ))[1] ;
$netMask  =
(split( ' ', qx(grep netmask /etc/sysconfig/interfaces) ))[1] ;
}
$ethernetSetup{'ip'} = $ipAddress ;
$ethernetSetup{'netmask'} = $netMask ;
my $mtu = (split( ' ', qx(grep mtu /etc/sysconfig/interfaces) ))[4] ;
$mtu = 1500 if ( ! $mtu ) ;
$ethernetSetup{ 'mtu' } = $mtu ;
my $gateway = '' ;
@results = grep( /^0.0.0.0/, qx| /sbin/route -n | ) ;
if (@results)
{
$gateway = (split( / +/, $results[0] ))[1] ;
}
elsif ($ethernetSetup{'ipmode'} eq 'static')
{
$gateway =
(split( ' ', qx(grep gateway /etc/sysconfig/interfaces) ))[1] ;
}
$ethernetSetup{'gateway'} = $gateway ;
@results = qx| cat /etc/resolv.conf | ;
chomp( @results ) ;
my @DnsServers = grep( s/^nameserver +//, @results ) ;
my $domain = (grep( s/^domain +//, @results ))[0] ;
my $searchPath = (grep( s/^search +//, @results ))[0];
if ($searchPath)
{
$searchPath = join( ',', split( ' ', $searchPath ) ) ;
}
$ethernetSetup{'nameServers'} = join( ',', @DnsServers ) ;
$ethernetSetup{'dnsDomain'} = $domain ;
$ethernetSetup{'dnsSearch'} = $searchPath ;
%{$hashRef} = %ethernetSetup ;
}
sub updateEthernetSetup
{
my %ethernetSetup = %{$_[0]} ;
my $ipmode = $ethernetSetup{ 'ipmode' } ;
my $NewIP ;
my $NewNetmask ;
my $NewGateway ;
my $network ;
my $broadcast ;
if ($ipmode eq 'static')
{
$NewIP = $ethernetSetup{ 'ip' } ;
$NewNetmask = $ethernetSetup{ 'netmask' } ;
$NewGateway = $ethernetSetup{ 'gateway' } ;
my @ipcomps = split( '\.', $NewIP ) ;
my @maskcomps = split( '\.', $NewNetmask ) ;
my @network ;
$network[0] = ($ipcomps[0]+0) & $maskcomps[0] ;
$network[1] = ($ipcomps[1]+0) & $maskcomps[1] ;
$network[2] = ($ipcomps[2]+0) & $maskcomps[2] ;
$network[3] = ($ipcomps[3]+0) & $maskcomps[3] ;
$network = join( '.', @network) ;
my @broadcast ;
$broadcast[0] = $network[0] | (255 ^ $maskcomps[0]) ;
$broadcast[1] = $network[1] | (255 ^ $maskcomps[1]) ;
$broadcast[2] = $network[2] | (255 ^ $maskcomps[2]) ;
$broadcast[3] = $network[3] | (255 ^ $maskcomps[3]) ;
$broadcast = join( '.', @broadcast) ;
}
open( OLDIF, '/etc/sysconfig/interfaces' ) ;
open( NEWIF, ">/tmp/interfaces" ) ;
my $line ;
MAINLOOP: while (<OLDIF>)
{
next MAINLOOP if m/^\s*#/;
next MAINLOOP if m/^\s*$/ ;
if ( m/^\s*iface\s+eth0/ )
{
if ($ipmode eq "static")
{
print NEWIF "iface eth0 inet static\n" ;
print NEWIF "    address $NewIP\n" ;
print NEWIF "    network $network\n" ;
print NEWIF "    netmask $NewNetmask\n" ;
print NEWIF "    broadcast $broadcast\n" ;
if ($NewGateway)
{
print NEWIF "    gateway $NewGateway\n" ;
}
}
else
{
print NEWIF "iface eth0 inet dhcp\n" ;
}
SKIP: while (<OLDIF>)
{
next SKIP if (m/^\s*(address|network|netmask|broadcast|gateway|up|down)/) ;
redo MAINLOOP ;
}
}
else
{
print  NEWIF $_ ;
}
}
print NEWIF "    up ifconfig eth0 mtu $ethernetSetup{'mtu'}\n" ;
close( NEWIF ) ;
close( OLDIF ) ;
if ($ipmode eq 'static')
{
open( RESOLV, ">/tmp/resolv.conf.new" ) ;
print RESOLV "#\n" ;
print RESOLV "# resolv.conf  This file is the resolver configuration file\n" ;
print RESOLV "# See resolver(5).\n" ;
print RESOLV "#\n" ;
print RESOLV "# Updated : ", qx| /bin/date |, "\n" ;
if ($ethernetSetup{ 'dnsDomain' })
{
print RESOLV "domain $ethernetSetup{'dnsDomain'}\n" ;
}
if ( my $path = $ethernetSetup{ 'dnsSearch' } )
{
$path =~ s/,/ /g ;
$path =~ s/  */ /g ;
print RESOLV "search ", $path, "\n" ;
}
for my $ns ( split( ',', $ethernetSetup{ 'nameServers' } ) )
{
print RESOLV "nameserver $ns\n" ;
}
close( RESOLV ) ;
installConfigFile( "resolv.conf.new", "resolv.conf" ) ;
}
system(
'(
/bin/sleep 5     # To let Web page finish updating.
/bin/date
/bin/echo "Installing new network configuration."
/usr/bin/sudo /etc/init.d/networking stop
/usr/bin/sudo cp /tmp/interfaces /etc/sysconfig/interfaces
/usr/bin/sudo /etc/init.d/networking start
/bin/echo "Network reconfiguration is done."
/bin/date
/bin/echo
) > /var/tmp/eth0reconfig.out 2>&1 &' ) ;
}
sub getSessionData
{
my $refHash = $_[0] ;
my %sessData ;
if ( open( SESSIONS, '/etc/sysconfig/sessions' ) )
{
while (<SESSIONS>)
{
next if (/^#/) ;
next if (/^\s$/) ;
my ($name, $enable, $sched, $time, $duration, $format, $naming )
= split( ' ', $_ ) ;
if ( $sched eq 'manual'
&& $enable == 1
)
{
my $gpsTime = time() - 315964800 + 13 ;
if ($gpsTime > $time+60*$duration)
{
$enable = 0 ;
}
}
$sessData{$name}{'enable'} = $enable ;
$sessData{$name}{'sched'} = $sched ;
$sessData{$name}{'time'} = $time ;
$sessData{$name}{'duration'} = $duration ;
my ($ftype, $field2, $field3, $field4, $field5, $field6 )
= split( ':', $format ) ;
$sessData{$name}{'ftype'} = $ftype ;
if ($ftype eq 'T00')
{
$sessData{$name}{'measInterval'} = $field2 ;
$sessData{$name}{'posInterval'} = $field3 ;
$sessData{$name}{'option1'} = $field4 ;
$sessData{$name}{'option2'} = $field5 ;
$sessData{$name}{'RT27'} = ( ($field6 & 0x01) != 0) ;
$sessData{$name}{'rawWaas'} = ( ($field6 & 0x02) != 0) ;
}
else
{
$sessData{$name}{'measInterval'} = $field2 ;
$sessData{$name}{'metaInterval'} = $field3 ;
$sessData{$name}{'statusInterval'} = $field4 ;
my $measOpts = hex( $field5 ) ;
$sessData{$name}{'smoothing'} =
( ($measOpts & 0x00000001) != 0 ) ;
$sessData{$name}{'7f02'} =   ( ($measOpts & 0x00000002) != 0 ) ;
$sessData{$name}{'7f03'} =   ( ($measOpts & 0x00000004) != 0 ) ;
$sessData{$name}{'7f03RxClkOfsRollover'} =
( ($measOpts & 0x00000008) != 0 ) ;
$sessData{$name}{'7f03RxClkOfsAlways'} =
( ($measOpts & 0x00000010) != 0 ) ;
$sessData{$name}{'7f03Slips'} =
( ($measOpts & 0x00000020) != 0 ) ;
$sessData{$name}{'7f03Doppler'} =
( ($measOpts & 0x00000040) != 0 ) ;
my $metaRecords = hex( $field6 ) ;
$sessData{$name}{'metTilt'} =
( ($metaRecords & 0x00000080) == 0 ) ;
$sessData{$name}{'siteDesc'} =
( ($metaRecords & 0x00000010) != 0 ) ;
$sessData{$name}{'stationID'} =
( ($metaRecords & 0x00008000) != 0 ) ;
$sessData{$name}{'antNum'} =
( ($metaRecords & 0x01000000) != 0 ) ;
$sessData{$name}{'rcvrType'} =
( ($metaRecords & 0x02000000) != 0 ) ;
$sessData{$name}{'rcvrNumber'} =
( ($metaRecords & 0x04000000) != 0 ) ;
$sessData{$name}{'firmwareVersion'} =
( ($metaRecords & 0x08000000) != 0 ) ;
$sessData{$name}{'antXYZ'} =
( ($metaRecords & 0x20000000) != 0 ) ;
$sessData{$name}{'antOffset'} =
( ($metaRecords & 0x80000000) != 0 ) ;
}
my ($sessid, $perday, $persessid, undef ) = split( ':', $naming );
$sessData{$name}{'sessid'} = $sessid ;
$sessData{$name}{'perday'} = $perday ;
$sessData{$name}{'persessid'} = $persessid ;
}
close( SESSIONS ) ;
}
%{$refHash} = %sessData ;
}
sub updateSessionData
{
my %sessData = %{$_[0]} ;
open( SESSIONS, '>/tmp/sessions.new' ) ;
print SESSIONS "#Name  Enb Type    Date/Time "
."Duration DataType        FileTemplate\n" ;
for my $name (sort keys %sessData)
{
my $format ;
if ($sessData{$name}{'ftype'} eq 'T00')
{
$format = sprintf( '%s:%s:%s:%d:%d:%d',
$sessData{$name}{'ftype'},
$sessData{$name}{'measInterval'},
$sessData{$name}{'posInterval'},
$sessData{$name}{'option1'} ? 1 : 0,
$sessData{$name}{'option2'} ? 1 : 0,
( ($sessData{$name}{'RT27'} ? 1 : 0)
+ ($sessData{$name}{'rawWaas'} ? 2 : 0)
)
) ;
}
elsif ($sessData{$name}{'ftype'} eq 'Binex')
{
my $measOpts = 0 ;
$measOpts |= 0x00000001 if ($sessData{$name}{'smoothing'}) ;
$measOpts |= 0x00000002 if ($sessData{$name}{'7f02'}) ;
$measOpts |= 0x00000004 if ($sessData{$name}{'7f03'}) ;
$measOpts |= 0x00000008
if ($sessData{$name}{'7f03RxClkOfsRollover'}) ;
$measOpts |= 0x00000010
if ($sessData{$name}{'7f03RxClkOfsAlways'}) ;
$measOpts |= 0x00000020 if ($sessData{$name}{'7f03Slips'}) ;
$measOpts |= 0x00000040 if ($sessData{$name}{'7f03Doppler'}) ;
my $metaRecords = 0 ;
$metaRecords |= 0x00000010 if ($sessData{$name}{'siteDesc'}) ;
$metaRecords |= 0x00008000 if ($sessData{$name}{'stationID'}) ;
$metaRecords |= 0x01000000 if ($sessData{$name}{'antNum'}) ;
$metaRecords |= 0x02000000 if ($sessData{$name}{'rcvrType'}) ;
$metaRecords |= 0x04000000 if ($sessData{$name}{'rcvrNumber'}) ;
$metaRecords |= 0x08000000
if ($sessData{$name}{'firmwareVersion'}) ;
$metaRecords |= 0x20000000 if ($sessData{$name}{'antXYZ'}) ;
$metaRecords |= 0x80000000 if ($sessData{$name}{'antOffset'}) ;
$metaRecords |= 0x00000080 if ( ! $sessData{$name}{'metTilt'}) ;
$format = sprintf( '%s:%s:%s:%s:%08x:%08x',
$sessData{$name}{'ftype'},
$sessData{$name}{'measInterval'},
$sessData{$name}{'metaInterval'},
$sessData{$name}{'statusInterval'},
$measOpts,
$metaRecords
) ;
}
else
{
$format = "unknownFormat" ;
}
printf( SESSIONS
"%-7s %1d  %-6s %10d %4d     %-15s %s:%1d:%1d:0\n",
$name,
$sessData{$name}{'enable'} ? 1 : 0 ,
$sessData{$name}{'sched'},
$sessData{$name}{'time'},
$sessData{$name}{'duration'},
$format,
$sessData{$name}{'sessid'},
$sessData{$name}{'perday'} ? 1 : 0,
$sessData{$name}{'persessid'} ? 1 : 0,
) ;
}
close( SESSIONS ) ;
installConfigFile( "sessions.new", "sessions" ) ;
if ( -f '/var/run/logScheduler.pid' )
{
my $spid = qx( cat /var/run/logScheduler.pid ) ;
system( "/usr/bin/sudo /bin/kill -SIGUSR1 $spid" ) ;
}
}
sub EnaDisSession
{
my $name = $_[0] ;
my $ena = ($_[1] ? 1 : 0) ;
my %sessData ;
getSessionData( \%sessData ) ;
return 0 if (! exists( $sessData{$name} ) ) ;
$sessData{$name}{'enable'} = $ena ;
if ( $sessData{$name}{'sched'} eq 'manual' )
{
if ( $ena eq '1' )
{
my $gpsTime = time() - 315964800 + 13 ;
$sessData{$name}{'time'} = $gpsTime + 10 ;
}
else
{
$sessData{$name}{'time'} = 0x7fffffff ;
}
}
updateSessionData( \%sessData ) ;
return 1 ;
}
sub getPortSetup
{
my $refHash = $_[0] ;
my %allPortData ;
for my $port ( 1..4 )
{
my $name = "SerialPort$port" ;
$allPortData{$name}{'protocol'} = 'serial' ;
$allPortData{$name}{'service'} = 'ppp' ;
$allPortData{$name}{'baud'} = 115200 ;
$allPortData{$name}{'flow'} = 'None' ;
$allPortData{$name}{'parity'} = 'None' ;
$allPortData{$name}{'pppbaud'} = 115200 ;
$allPortData{$name}{'pppflow'} = 'None' ;
my $pppFile ;
$pppFile = 'console'  if ($port == 1) ;
$pppFile = 'tts.1'    if ($port == 2) ;
$pppFile = 'tts_max0' if ($port == 3) ;
$pppFile = 'tts_max1' if ($port == 4) ;
my $localip = '0.0.0.0' ;
my $remoteip = '0.0.0.0' ;
my $flow = 'None' ;
if (open(PPP, "/etc/sysconfig/ppp/options.$pppFile" ))
{
while (<PPP>)
{
chomp ;
if (m/:/)
{
( $localip, $remoteip ) = split ':' ;
}
$flow = 'None' if (m/nocrtscts/ ) ;
$flow = 'Hardware' if (m/^\s*crtscts/ ) ;
}
close( PPP ) ;
}
$allPortData{$name}{'localip'} = $localip ;
$allPortData{$name}{'remoteip'} = $remoteip ;
$allPortData{$name}{'pppflow'} = $flow ;
}
if (open(MGETTY, '/etc/sysconfig/mgetty+sendfax/mgetty.config'))
{
my $line ;
while ($line = <MGETTY>)
{
$_ = $line ;
next if (m/^#/) ;
next if (m/^\s*$/) ;
if (m/^\s*port\s/ )
{
my (undef, $device) = split ;
my $externalPortNum ;
$externalPortNum = 1 if ($device eq 'console') ;
$externalPortNum = 2 if ($device eq 'tts/1') ;
$externalPortNum = 3 if ($device eq 'tts_max0') ;
$externalPortNum = 4 if ($device eq 'tts_max1') ;
my $internalPortNum = $externalPortNum - 1 ;
my $portName = "SerialPort$externalPortNum" ;
my $baud   = 115200 ;
my $direct = 'y' ;
my $reset = '' ;
my ( $init1, $init2, $init3 ) = ('','','') ;
while ($line = <MGETTY>)
{
$_ = $line ;
last if (m/^\s*$/) ;
if (m/^\s*port\s/ )
{
$line = $_ ;
last ;
}
if (m/speed/)
{
(undef, $baud ) = split ;
}
if (m/direct/)
{
(undef, $direct ) = split ;
}
if (m/force-init/)
{
(undef, undef, $reset, undef ) = split ;
}
if (m/init-chat/)
{
(undef, undef, $init1, undef, $init2, undef, $init3)
= split ;
}
}
$allPortData{$portName}{'pppbaud'} = $baud ;
$allPortData{$portName}{'connection'} = $direct eq 'y'
? 'Direct'
: 'Modem' ;
$allPortData{$portName}{'reset'} = $reset ;
$allPortData{$portName}{'init1'} = $init1 ;
$allPortData{$portName}{'init2'} = $init2 ;
$allPortData{$portName}{'init3'} = $init3 ;
redo if ($line =~ m/^\s*port\s/ ) ;
}
}
close( MGETTY ) ;
}
if ( open( GPSSD, '/etc/sysconfig/gpssd.config' ) )
{
while (<GPSSD>)
{
next if (/^#/) ;
next if (/^\s$/) ;
if (/^AuthKey /)
{
my $authKey = (split( ' ', $_ ))[1] ;
$allPortData{'AuthKey'} = $authKey ;
next ;
}
my ( $port, $protocol,
$field3, $field4, $field5, $field6, $field7, $field8,
$field9, $field10, undef
) = split( ' ', $_ ) ;
my $enable = 1 ;
if ($protocol =~ /^OFF-/)
{
$enable = 0 ;
$protocol =~ s/^OFF-// ;
}
my $authenticate = 0 ;
if ($protocol =~ /-A$/)
{
$authenticate = 1 ;
$protocol =~ s/-A$// ;
}
my $service = $field5 ;
next if ($service eq 'metdata') ;
my $name ;
if ( $protocol eq 'serial')
{
++$port ;
$name = "SerialPort$port" ;
$allPortData{$name}{'protocol'} = 'serial' ;
my ($baud, $parity, $flow ) = split( ':', $field3 ) ;
$allPortData{$name}{'baud'} = $baud ;
$parity = 'None' if $parity eq 'N' ;
$parity = 'Odd'  if $parity eq 'O' ;
$parity = 'Even' if $parity eq 'E' ;
$allPortData{$name}{'parity'} = $parity ;
$flow = 'None' if $flow eq 'N' ;
$flow = 'Hardware' if $flow eq 'H' ;
$flow = 'XonXoff' if $flow eq 'S' ;
$allPortData{$name}{'flow'} = $flow ;
if ($service eq 'ppp')
{
$allPortData{$name}{'ppptoggle'} = $field6 ;
}
}
elsif ($protocol eq 'tcp')
{
$name = "TcpPort$port" ;
$allPortData{$name}{'protocol'} = 'tcp' ;
}
elsif ($protocol eq 'udp')
{
$name = "UdpPort$port" ;
$allPortData{$name}{'protocol'} = 'udp' ;
$allPortData{$name}{'udptimeout'} = $field4 ;
}
elsif ($protocol eq 'rep')
{
$name = "RepPort$port" ;
$allPortData{$name}{'protocol'} = 'rep' ;
}
$service = 'Trimcom' if ($service eq 'trimcom') ;
$service = 'Met' if ($service eq 'met') ;
if ($service eq 'rt17')
{
$service = 'RT17' ;
my $interval = $field6 / 10 ;
if ($interval < 1.0)
{
$interval = sprintf( "%.1f", $interval)
}
else
{
$interval = sprintf( "%.0f", $interval)
}
$allPortData{$name}{'interval'} = $interval ;
if ($field7 & 8)
{
$allPortData{$name}{'positions'} = 1 ;
$allPortData{$name}{'measurements'} = 1 ;
}
elsif ($field7 & 16)
{
$allPortData{$name}{'positions'} = 1 ;
$allPortData{$name}{'measurements'} = 0 ;
}
else
{
$allPortData{$name}{'positions'} = 0 ;
$allPortData{$name}{'measurements'} = 1 ;
}
$allPortData{$name}{'concise'} = ($field7 & 1)  ;
$allPortData{$name}{'iodeslips'} = ($field7 & 2) >> 1  ;
$allPortData{$name}{'gpsdata'} = ($field7 & 4) >> 2  ;
$allPortData{$name}{'rawgps'} = ($field7 & 32) >> 5  ;
$allPortData{$name}{'rawwaas'} = ($field7 & 64) >> 6  ;
$allPortData{$name}{'smoothcode'} = ($field7 & 128) >> 7  ;
$allPortData{$name}{'smoothcarrier'} = ($field7 & 256) >> 8  ;
$allPortData{$name}{'useRt27'} = ($field7 & 512) >> 9  ;
}
if ($service eq 'nmea')
{
$service = 'NMEA' ;
my @intervals = split /,/ , $field6 ;
foreach $msg (@nmeaMessages)
{
$allPortData{$name}{$msg} = shift( @intervals ) ;
}
}
if ($service eq 'binex')
{
$service = 'Binex' ;
my $interval = $field6 / 10 ;
if ($interval < 1.0)
{
$interval = sprintf( "%.1f", $interval)
}
else
{
$interval = sprintf( "%.0f", $interval)
}
$allPortData{$name}{'interval'} = $interval ;
my $measOpts = hex( $field7 ) ;
$allPortData{$name}{'smoothing'} =
( ($measOpts & 0x00000001) != 0 ) ;
$allPortData{$name}{'7f02'} =
( ($measOpts & 0x00000002) != 0 ) ;
$allPortData{$name}{'7f03'} =
( ($measOpts & 0x00000004) != 0 ) ;
$allPortData{$name}{'7f03RxClkOfsRollover'} =
( ($measOpts & 0x00000008) != 0 ) ;
$allPortData{$name}{'7f03RxClkOfsAlways'} =
( ($measOpts & 0x00000010) != 0 ) ;
$allPortData{$name}{'7f03Slips'} =
( ($measOpts & 0x00000020) != 0 ) ;
$allPortData{$name}{'7f03Doppler'} =
( ($measOpts & 0x00000040) != 0 ) ;
$allPortData{$name}{'metTilt'} =
( ($measOpts & 0x00000080) == 0 ) ;
$allPortData{$name}{'metaInterval'} = $field8 ;
my $metaRecords = hex( $field9 ) ;
$allPortData{$name}{'siteDesc'} =
( ($metaRecords & 0x00000010) != 0 ) ;
$allPortData{$name}{'stationID'} =
( ($metaRecords & 0x00008000) != 0 ) ;
$allPortData{$name}{'antNum'} =
( ($metaRecords & 0x01000000) != 0 ) ;
$allPortData{$name}{'rcvrType'} =
( ($metaRecords & 0x02000000) != 0 ) ;
$allPortData{$name}{'rcvrNumber'} =
( ($metaRecords & 0x04000000) != 0 ) ;
$allPortData{$name}{'firmwareVersion'} =
( ($metaRecords & 0x08000000) != 0 ) ;
$allPortData{$name}{'antXYZ'} =
( ($metaRecords & 0x20000000) != 0 ) ;
$allPortData{$name}{'antOffset'} =
( ($metaRecords & 0x80000000) != 0 ) ;
$allPortData{$name}{'statusInterval'} = $field10 ;
}
elsif ($service eq 'cmr')
{
$service = 'CMR' ;
$allPortData{$name}{'cmrStyle'} = ($field7 == 1)
? 'Standard'
: 'CmrPlus' ;
}
elsif ($service eq 'rtcm')
{
$service = 'Rtcm' ;
my $version ;
$version = '2.1' if ($field8 == 0) ;
$version = '2.2' if ($field8 == 1) ;
$version = '2.3' if ($field8 == 2) ;
$version = '3.0' if ($field8 == 3) ;
$allPortData{$name}{'version'} = $version ;
my $style ;
$style = 'DGPS' if ($field7 == 0) ;
$style = 'RTK' if ($field7 == 1) ;
$style = 'DGPS_RTK' if ($field7 == 2) ;
if ($field7 == 3)
{
$style = 'Custom:' ;
$style .= '1,' if ($field9 & 0x001) ;
$style .= '2,' if ($field9 & 0x002) ;
$style .= '3,' if ($field9 & 0x004) ;
$style .= '9,' if ($field9 & 0x008) ;
$style .= '14,' if ($field9 & 0x010) ;
$style .= '18+19,' if ($field9 & 0x020) ;
$style .= '22,' if ($field9 & 0x040) ;
$style .= '23+24,' if ($field9 & 0x180) ;
$style .= '59.3,' if ($field9 & 0x200) ;
$style .= '59.13,' if ($field9 & 0x400) ;
$style =~ s/,$// ;
}
$allPortData{$name}{'rtcmStyle'} = $style ;
}
elsif ($service eq 'service')
{
$service = 'SvStatus' if ($field6 == 0) ;
$service = 'Ephemerides' if ($field6 == 1) ;
$service = 'Almanacs' if ($field6 == 2) ;
$service = 'internal3' if ($field6 == 3) ;
$service = 'internal4' if ($field6 == 4) ;
}
if ( $service eq 'internal3'
|| $service eq 'internal4'
)
{
delete( $allPortData{$name} ) ;
next ;
}
$allPortData{$name}{'service'} = $service ;
$allPortData{$name}{'enable'} = $enable ;
$allPortData{$name}{'authenticate'} = $authenticate ;
$allPortData{$name}{'field3'} = $field3 ;
$allPortData{$name}{'field4'} = $field4 ;
$allPortData{$name}{'field5'} = $field5 ;
$allPortData{$name}{'field6'} = $field6 ;
$allPortData{$name}{'field7'} = $field7 ;
$allPortData{$name}{'field8'} = $field8 ;
$allPortData{$name}{'field9'} = $field9 ;
}
}
close( GPSSD ) ;
for my $n (1..6)
{
$allPortData{'MetControls'}{$n} = "off" ;
}
if (open( METCONF, '/etc/sysconfig/met.conf' ))
{
my $i = 1 ;
while (<METCONF>)
{
chomp ;
my ($time, $cmd) = split ;
$cmd = '' if (!$cmd ) ;
$time = 'once' if ($time eq '0') ;
$allPortData{'MetControls'}{$i++} = "$time:$cmd" ;
}
close( METCONF ) ;
}
%{$refHash} = %allPortData ;
}
sub saveGpssdConfig
{
my %allPortData = %{$_[0]} ;
my $newFile   = 'gpssd.config.new' ;
open( GPSSD, ">/tmp/$newFile" ) ;
my @portList = sort keys %allPortData ;
@portList = grep !/MetControls/, @portList ;
@portList = ( (grep /Auth|Serial/, @portList),
(grep !/Auth|Serial/, @portList)
) ;
for my $name (@portList)
{
if ( $name eq 'AuthKey' )
{
print GPSSD "AuthKey $allPortData{'AuthKey'}\n" ;
next ;
}
my %portData = %{$allPortData{$name}} ;
my $portNumber = $name ;
$portNumber =~ s/.*Port// ;
my $protocol = lc($name) ;
$protocol =~ s/^(tcp|udp|rep|serial).*$/$1/ ;
--$portNumber if ($protocol eq 'serial') ;
my $baud = $portData{'baud'} || 0 ;
if ($baud != 0)
{
my $flow = $portData{'flow'} ;
$flow = 'N' if ( ! $flow or $flow =~ /none/i ) ;
$flow = 'H' if ($flow =~ /hardware/i) ;
$flow = 'S' if ($flow =~ /xonxoff/i) ;
my $parity = $portData{'parity'} ;
$parity = 'N' if ( ! $parity  or $parity =~ /none/i ) ;
$parity = 'E' if ($parity =~ /even/i) ;
$parity = 'O' if ($parity =~ /odd/i) ;
$baud .= ":$parity:$flow" ;
}
my $udptimeout = $portData{'udptimeout'} || 0 ;
my $service = lc( $portData{'service'} ) ;
my $field6 = 0 ;
my $field7 = '' ;
my $field8 = '' ;
my $field9 = '' ;
my $field10 = '' ;
if ($service eq 'svstatus' )
{
print GPSSD "# service 0 = SV status\n" ;
$service = 'service' ;
$field6 = 0 ;
}
elsif ($service eq 'ephemerides' )
{
print GPSSD "# service 1 = Ephemerides\n" ;
$service = 'service' ;
$field6 = 1 ;
}
elsif ($service eq 'almanacs' )
{
print GPSSD "# service 2 = Almanacs\n" ;
$service = 'service' ;
$field6 = 2 ;
}
elsif ($service eq 'internal3' )
{
}
elsif ($service eq 'internal4' )
{
}
elsif ($service eq 'rt17' )
{
$field6 = $portData{'interval'} * 10 ;
$field7 = 0 ;
$field7 |= 1   if ($portData{'concise'}) ;
$field7 |= 2   if ($portData{'iodeslips'}) ;
$field7 |= 4   if ($portData{'gpsdata'}) ;
$field7 |= 32  if ($portData{'rawgps'}) ;
$field7 |= 64  if ($portData{'rawwaas'}) ;
$field7 |= 128 if ($portData{'smoothcode'}) ;
$field7 |= 256 if ($portData{'smoothcarrier'}) ;
$field7 |= 512 if ($portData{'useRt27'}) ;
$field7 |= 8   if ( $portData{'positions'}
&& $portData{'measurements'}
) ;
$field7 |= 16  if ( $portData{'positions'}
&& ! $portData{'measurements'}
) ;
}
elsif ($service eq 'binex' )
{
$field6 = $portData{'interval'} * 10 ;
my $measOpts = 0 ;
$measOpts |= 0x00000001 if ($portData{'smoothing'}) ;
$measOpts |= 0x00000002 if ($portData{'7f02'}) ;
$measOpts |= 0x00000004 if ($portData{'7f03'}) ;
$measOpts |= 0x00000008 if ($portData{'7f03RxClkOfsRollover'}) ;
$measOpts |= 0x00000010 if ($portData{'7f03RxClkOfsAlways'}) ;
$measOpts |= 0x00000020 if ($portData{'7f03Slips'}) ;
$measOpts |= 0x00000040 if ($portData{'7f03Doppler'}) ;
$measOpts |= 0x00000080 if ( ! $portData{'metTilt'}) ;
$field7 = sprintf( "%08X ", $measOpts ) ;
$field8 = $portData{'metaInterval'} ;
$field10 = $portData{'statusInterval'} ;
my $metaRecords = 0 ;
$metaRecords |= 0x00000010 if ($portData{'siteDesc'}) ;
$metaRecords |= 0x00008000 if ($portData{'stationID'}) ;
$metaRecords |= 0x01000000 if ($portData{'antNum'}) ;
$metaRecords |= 0x02000000 if ($portData{'rcvrType'}) ;
$metaRecords |= 0x04000000 if ($portData{'rcvrNumber'}) ;
$metaRecords |= 0x08000000
if ($portData{'firmwareVersion'}) ;
$metaRecords |= 0x20000000 if ($portData{'antXYZ'}) ;
$metaRecords |= 0x80000000 if ($portData{'antOffset'}) ;
$field9 = sprintf( "%08X ", $metaRecords ) ;
}
elsif ($service eq 'nmea' )
{
$field6 = '' ;
my $msg ;
my $needComma = 0 ;
foreach $msg (@nmeaMessages)
{
$field6 .= ',' if $needComma ;
$needComma = 1 ;
$field6 .= $portData{$msg} ;
}
}
elsif ($service eq 'met' )
{
$field6  = '10' ;
$field7  = '0' ;
$field8  = '0' ;
}
elsif ($service eq 'trimcom' )
{
$field6  = '10' ;
$field7  = '0' ;
}
elsif ($service eq 'cmr' )
{
$field6 = '10' ;
my $style = lc($portData{'cmrStyle'}) ;
$field7  = $style eq 'standard' ? 1 : 2 ;
}
elsif ($service eq 'rtcm' )
{
$field6 = 10 ;
my $version = $portData{'version'} ;
$field8 = 0 ;
$field8 = 1 if ($version eq '2.2') ;
$field8 = 2 if ($version eq '2.3') ;
$field8 = 3 if ($version eq '3.0') ;
my $style = lc($portData{'rtcmStyle'}) ;
$field7 = 0 ;
$field9 = 0 ;
$field7 = 1 if ($style eq 'rtk') ;
$field7 = 2 if ($style eq 'dgps_rtk') ;
if ($style =~ /custom/)
{
$field7 = 3 ;
$style =~ s/custom://i ;
for my $bit (split( ',', $style ) )
{
$field9 |= 1    if ($bit eq '1') ;
$field9 |= 2    if ($bit eq '2') ;
$field9 |= 4    if ($bit eq '3') ;
$field9 |= 8    if ($bit eq '9') ;
$field9 |= 16   if ($bit eq '14') ;
$field9 |= 32   if ($bit eq '18+19') ;
$field9 |= 64   if ($bit eq '22') ;
$field9 |= 384  if ($bit eq '23+24') ;
$field9 |= 512  if ($bit eq '59.3') ;
$field9 |= 1024 if ($bit eq '59.13') ;
}
}
}
elsif ($service eq 'ppp' )
{
$field6 = $portData{'ppptoggle'} || 1 ;
$field7 = 0 ;
}
elsif ($service eq 'ppp-dialout' )
{
$field6 = 1 ;
$field7 = 0 ;
}
my $enable = $portData{'enable'} ;
if (!$enable)
{
$protocol = 'OFF-'.$protocol ;
}
if ($portData{'authenticate'})
{
$protocol = $protocol.'-A' ;
}
printf GPSSD "%-5d %-9s %10s %2d %-7s %s %s %s %s %s \n",
$portNumber,
$protocol,
$baud,
$udptimeout,
$service,
$field6,
$field7,
$field8,
$field9,
$field10 ;
}
close( GPSSD ) ;
installConfigFile( $newFile, "gpssd.config" ) ;
if ( -e '/var/run/gpssd.pid' )
{
my $pid = qx( cat /var/run/gpssd.pid ) ;
system( "/usr/bin/sudo kill -SIGHUP $pid" ) ;
}
}
sub saveMetConfig
{
my %allPortData = %{$_[0]} ;
open( METCONF, '>/tmp/met.conf.new' ) ;
for my $n (1..6)
{
my $cmd = $allPortData{'MetControls'}{$n} ;
next if ($cmd eq 'off') ;
my ($time, $string) = split( ':', $cmd ) ;
$time = 0 if ( $time =~ /^once$/i ) ;
print METCONF "$time $string\n" ;
}
close( METCONF ) ;
installConfigFile( "met.conf.new", "met.conf" ) ;
}
sub savePppConfig
{
my %allPortData = %{$_[0]} ;
open( MGETTY, '/etc/sysconfig/mgetty+sendfax/mgetty.config') ;
open( NEWMGETTY, '>/tmp/mgetty.config' ) ;
while (<MGETTY>)
{
next if (/^# SerialPort[1234]/) ;
last if (/^\s*port\s/) ;
print NEWMGETTY ;
}
close MGETTY ;
for my $p (1..4)
{
my $port = "SerialPort$p" ;
print NEWMGETTY "# $port\n" ;
my $device ;
$device='console' if ($p == 1) ;
$device='tts/1' if ($p == 2) ;
$device='tts_max0' if ($p == 3) ;
$device='tts_max1' if ($p == 4) ;
print NEWMGETTY "port $device\n" ;
print NEWMGETTY "  direct ",
($allPortData{$port}{'connection'} =~ /Direct/i)
? 'y'
: 'n',
"\n" ;
print NEWMGETTY "  speed ",
$allPortData{$port}{'pppbaud'},
"\n" ;
print NEWMGETTY "  toggle-dtr n\n" ;
my $resetString = $allPortData{$port}{'reset'} ;
if ( length($resetString) )
{
print NEWMGETTY '  force-init "" ', $resetString, "\n" ;
}
my $initString1 = $allPortData{$port}{'init1'} ;
$initString1 = '' if (!defined $initString1) ;
my $initString2 = $allPortData{$port}{'init2'} ;
$initString2 = '' if (!defined $initString2) ;
my $initString3 = $allPortData{$port}{'init3'} ;
$initString3 = '' if (!defined $initString3) ;
if ( length( $initString1 )
or length( $initString2 )
or length( $initString3 )
)
{
print NEWMGETTY '  init-chat ""' ;
print NEWMGETTY " $initString1 OK" if ( length( $initString1 ) ) ;
print NEWMGETTY " $initString2 OK" if ( length( $initString2 ) ) ;
print NEWMGETTY " $initString3 OK" if ( length( $initString3 ) ) ;
print NEWMGETTY "\n" ;
}
print NEWMGETTY "  debug 0\n";
print NEWMGETTY "\n" ;
}
close NEWMGETTY ;
installConfigFile( "mgetty.config", 'mgetty+sendfax/mgetty.config' );
for my $p (1..4)
{
my $port = "SerialPort$p" ;
my $pppFile ;
$pppFile='console' if ($p == 1) ;
$pppFile='tts.1' if ($p == 2) ;
$pppFile='tts_max0' if ($p == 3) ;
$pppFile='tts_max1' if ($p == 4) ;
$pppFile="options.$pppFile" ;
open( NEWPPPFILE, ">/tmp/$pppFile" ) ;
if (open( OLDPPPFILE, "/etc/sysconfig/ppp/$pppFile" ) )
{
while (<OLDPPPFILE>)
{
next if ( m/:/ ) ;
next if (m/local/) ;
next if (m/crtscts/) ;
next if (m/^\s$/) ;
print NEWPPPFILE $_ ;
}
close OLDPPPFILE ;
}
my $flow= $allPortData{$port}{'pppflow'} ;
$flow = ($flow =~ /hardware/i)
? 'crtscts'
: 'nocrtscts' ;
print NEWPPPFILE $allPortData{$port}{'localip'},
':',
$allPortData{$port}{'remoteip'},
"\n",
$flow,
"\n" ;
print NEWPPPFILE "local\n"
if ( $allPortData{$port}{'connection'} =~ /Direct/i ) ;
close PPPFILE ;
installConfigFile( $pppFile, "ppp/$pppFile" ) ;
}
}
sub sendBinaryFile
{
my $pathname = $_[0] ;
my $fname = $pathname ;
$fname =~ s/^.*\/// ;
my $length = (-s $pathname) ;
print header(
'-Content-Type'        => 'application/force-download',
'-Content-length'      => $length,
'-expires'             => '+1s',
) ;
open THEFILE,  $pathname  || return ;
my $buf ;
while ( read( THEFILE, $buf, 4096 ) )
{
print $buf ;
}
}
sub getRefStationData
{
my %refStationData ;
open( SYSINFO,
'/usr/local/fireball/sysinfo -p ref_stn |'
) ;
while (<SYSINFO>)
{
if ( my ($tag, $value) = m/^\s*(\S*)\s*:\s*(.*)\s*$/ )
{
$refStationData{'lat'} = $value if ($tag eq "Lat" ) ;
$refStationData{'lon'} = $value if ($tag eq "Lon" ) ;
$refStationData{'height'} = $value if ($tag eq "Height" ) ;
$refStationData{'x'} = $value if ($tag eq "X" ) ;
$refStationData{'y'} = $value if ($tag eq "Y" ) ;
$refStationData{'z'} = $value if ($tag eq "Z" ) ;
$refStationData{'rtcmid'} = $value if ($tag eq "RTCM_ID" ) ;
$refStationData{'cmrid'} = $value if ($tag eq "CMR_ID" ) ;
$refStationData{'binexid'} = $value if ($tag eq "BINEX_ID" ) ;
$refStationData{'cmrStationName'} = $value if ($tag eq "StationName" ) ;
$refStationData{'rtcmdesc'} = $value if ($tag eq "StationDesc" ) ;
}
}
close( SYSINFO ) ;
my $latitude = $refStationData{'lat'} ;
my $longitude = $refStationData{'lon'} ;
my ($deg, $min, $sec, $dir ) ;
$dir = 'N' ;
if ($latitude < 0.0)
{
$latitude = - $latitude ;
$dir = 'S' ;
}
$latitude += (0.000005 / 3600) ;
$deg   = int( $latitude ) ;
$latitude = ($latitude - $deg) * 60 ;
$min   = int( $latitude ) ;
$sec   = ($latitude - $min) * 60 ;
$sec   = int($sec * 100000.0)/100000.0 ;
$refStationData{'latdeg'} = $deg ;
$refStationData{'latmin'} = $min ;
$refStationData{'latsec'} = $sec ;
$refStationData{'latns'}  = $dir ;
$dir = 'E' ;
if ($longitude < 0.0)
{
$longitude = - $longitude ;
$dir = 'W' ;
}
$longitude += (0.000005 / 3600) ;
$deg   = int( $longitude ) ;
$longitude = ($longitude - $deg) * 60 ;
$min   = int( $longitude ) ;
$sec   = ($longitude - $min) * 60 ;
$sec   = int($sec * 100000.0)/100000.0 ;
$refStationData{'londeg'} = $deg ;
$refStationData{'lonmin'} = $min ;
$refStationData{'lonsec'} = $sec ;
$refStationData{'lonew'}  = $dir ;
%{$_[0]} = %refStationData ;
}
sub updateRefStationData
{
my %refStationData = %{$_[0]} ;
my $xyz = $_[1] ;
open( NEWCONF, '>/tmp/ref_stn.config.new' ) ;
if (open( OLDCONF, '/etc/sysconfig/ref_stn.config' ))
{
while (<OLDCONF>)
{
if ( ! m/^\s*(Lat|Lon|Height|X|Y|Z|BINEX_ID)\s*:/
&& ! m/^\s*(RTCM_ID|CMR_ID|StationName|StationDesc)\s*:/)
{
print NEWCONF $_ ;
}
}
close( OLDCONF ) ;
}
if ($xyz)
{
printf NEWCONF "X: %12.4f\n", $refStationData{'x'} ;
printf NEWCONF "Y: %12.4f\n", $refStationData{'y'} ;
printf NEWCONF "Z: %12.4f\n", $refStationData{'z'} ;
}
else
{
printf NEWCONF "Lat:    %17.12f\n", $refStationData{'lat'} ;
printf NEWCONF "Lon:    %17.12f\n", $refStationData{'lon'} ;
printf NEWCONF "Height: %8.4f\n", $refStationData{'height'}  ;
}
print NEWCONF "RTCM_ID: ", $refStationData{'rtcmid'},"\n",
"CMR_ID:  ", $refStationData{'cmrid'},"\n",
"BINEX_ID:  ", $refStationData{'binexid'},"\n",
"StationName: ", $refStationData{'cmrStationName'},"\n",
"StationDesc: ", $refStationData{'rtcmdesc'},"\n" ;
close( NEWCONF ) ;
installConfigFile( "ref_stn.config.new", "ref_stn.config" ) ;
system( 'sudo /usr/local/fireball/sysinfo -m' ) ;
}
sub getNtpServers
{
my @servers ;
if ( open( NTPCONF, '/etc/sysconfig/ntp.conf' ) )
{
while (<NTPCONF>)
{
push( @servers, ((split())[1]) )
if (m/^server .*# External Server$/) ;
}
close( NTPCONF ) ;
}
return @servers ;
}
sub saveNtpServers
{
my @servers = @_ ;
open( OLDCONF, '/etc/sysconfig/ntp.conf' ) ;
open( NEWCONF, '>/tmp/ntp.conf.new' ) ;
while (<OLDCONF>)
{
print NEWCONF $_  if ( ! m/^server .*# External Server$/) ;
}
for my $server (@servers)
{
print NEWCONF "server $server # External Server\n" ;
}
close( NEWCONF ) ;
close( OLDCONF ) ;
installConfigFile( "ntp.conf.new", "ntp.conf" ) ;
if ($servers[0])
{
open( NEWCONF, '>/tmp/step-tickers.new' ) ;
print NEWCONF "$servers[0]\n" ;
close NEWCONF ;
installConfigFile( "step-tickers.new", "step-tickers" ) ;
}
else
{
if ( -f '/etc/sysconfig/step-tickers' )
{
system( 'sudo rm /etc/sysconfig/step-tickers' ) ;
}
}
my $ntpPID = 0 ;
open( PS, '/bin/ps |' ) ;
while (<PS>)
{
my ($pid, undef, undef, undef, $process, undef) = split ;
if ( $process eq 'ntpd' )
{
$ntpPID = $pid ;
last ;
}
}
close( PS ) ;
if ($ntpPID)
{
system( "/usr/bin/sudo kill $ntpPID" ) ;
}
}
sub getIoStatus
{
my $sun = sockaddr_un( '/var/spool/gpssd_info' ) ;
socket( SOCK, PF_UNIX, SOCK_STREAM, PF_UNSPEC) ;
connect( SOCK, $sun ) ;
SOCK->autoflush(1) ;
my %streams ;
my @clients ;
while (<SOCK>)
{
my @fields = split ;
if (m|^\d\d [^\d]|)
{
my $id = $fields[0] ;
$id =~ s|/..:|| ;
my $protocol = $fields[1] ;
my $port = $fields[2]+0 ;
++$port if ($protocol eq 'serial') ;
my $service = $fields[9] ;
$service = $fields[10] if ( $service eq 'service' ) ;
$streams{$id} = { 'protocol' => $protocol ,
'port' => $port,
'service' => $service,
} ;
next ;
}
if (m/^\d\d /)
{
my $id = $fields[0] ;
my $hexIP = $fields[2] ;
$hexIP =~ s/:.*// ;
my $ip = hex( substr( $hexIP, 0, 2 ) ) ;
$ip .= '.' ;
$ip .= hex( substr( $hexIP, 2, 2 ) ) ;
$ip .= '.' ;
$ip .= hex( substr( $hexIP, 4, 2 ) ) ;
$ip .= '.' ;
$ip .= hex( substr( $hexIP, 6, 2 ) ) ;
my $service = $streams{$id}{'service'} ;
my $protocol = $streams{$id}{'protocol'} ;
my $port = $streams{$id}{'port'} ;
my $name ;
$name = "SerialPort$port" if ($protocol eq 'serial') ;
$name = "TcpPort$port" if ($protocol eq 'tcp') ;
$name = "UdpPort$port" if ($protocol eq 'udp') ;
if ( ($service ne 'info')
&& ($service ne 'metdata')
)
{
my %client = ( 'name' => $name,
'protocol' => $protocol,
'port' => $port,
'service' => $service,
'ip' => $ip,
) ;
push @clients, \%client ;
}
}
}
close SOCK ;
@clients = sort( {${$a}{'name'} cmp ${$b}{'name'}} @clients ) ;
return @clients ;
}
sub getAutoDeleteControls
{
my $refToHash = $_[0] ;
my %autoDeleteControls ;
if ( open( AUTODELETE, '/etc/sysconfig/autoDelete' ) )
{
while (<AUTODELETE>)
{
chomp ;
my ($pool, $size, $enable) = split ;
if ($pool eq 'yes' or $pool eq 'no')
{
$enable = 'yes' ;
$pool = 'Reserved' ;
$size = 1000000 ;
}
$pool = 'Reserved' if ($pool eq 'Global') ;
$autoDeleteControls{$pool}{'size'} = $size/1000000 ;
$autoDeleteControls{$pool}{'enable'} = ($enable eq 'yes') ;
}
close AUTODELETE ;
}
else
{
$autoDeleteControls{'Reserved'}{'size'} = 1 ;
$autoDeleteControls{'Reserved'}{'enable'} = 1 ;
}
%{$refToHash} = %autoDeleteControls ;
}
sub saveAutoDeleteControls
{
my %autoDeleteControls = %{$_[0]} ;
open( AUTODELETE, '>/tmp/autoDelete.new' ) ;
for my $pool ('Reserved','a'..'z','Default')
{
if (exists $autoDeleteControls{$pool})
{
printf AUTODELETE "%-8s %10d %s\n",
$pool,
$autoDeleteControls{$pool}{'size'}*1000000,
$autoDeleteControls{$pool}{'enable'} ? 'yes' : 'no'
;
}
}
close( AUTODELETE ) ;
installConfigFile( "autoDelete.new", "autoDelete" ) ;
if ( -f '/var/run/autoDelete.pid' )
{
my $spid = qx( cat /var/run/autoDelete.pid ) ;
system( "/usr/bin/sudo /bin/kill -SIGHUP $spid" ) ;
}
}
sub getPoolStatus
{
my $refToHash = $_[0] ;
my %poolStatus ;
if ( open( POOLSTATUS, '/var/run/poolStatus' ) )
{
while (<POOLSTATUS>)
{
chomp ;
my ($pool, $ad, $maxsize, $size, $files) = split ;
$poolStatus{$pool}{'ad'} = $ad ;
$poolStatus{$pool}{'maxsize'} = $maxsize ;
$poolStatus{$pool}{'size'} = $size ;
$poolStatus{$pool}{'files'} = $files ;
}
close POOLSTATUS ;
}
%{$refToHash} = %poolStatus ;
}
sub installConfigFile
{
my $newFile = $_[0] ;
my $finalFile = $_[1] ;
chmod( 0444, "/tmp/$newFile" ) ;
system( '/usr/bin/sudo',
'/bin/chown',
'root:root',
"/tmp/$newFile"
) ;
system( '/usr/bin/sudo',
'/bin/mv',
"/tmp/$newFile",
'/etc/sysconfig'
) ;
system( '/usr/bin/sudo',
'/bin/mv',
"/etc/sysconfig/$newFile",
"/etc/sysconfig/$finalFile"
) ;
}
sub newStingerConfig
{
my $newLine = $_[0] ;
my $sun = sockaddr_un('/var/stinger/config')|| die "no config";
socket(SOCK, PF_UNIX, SOCK_STREAM, PF_UNSPEC)|| die "socket: $!";
connect(SOCK,$sun)|| die "connect: $!";
SOCK->autoflush(1);
print( SOCK  $newLine ) ;
$_ = <SOCK> ;
close(SOCK) ;
my $function = (split ' ', $newLine )[1] ;
open( NEWCONFIG, '>/tmp/stinger.new' ) ;
if ( open( OLDCONFIG, '/etc/sysconfig/stinger.cfg' ) )
{
while (<OLDCONFIG>)
{
next if (/^put\s$function\s/) ;
next if ( $function eq 'l2_mode' and /^put\sl2cs_mode\s/ ) ;
print NEWCONFIG $_ ;
}
}
close OLDCONFIG ;
print NEWCONFIG $newLine ;
close NEWCONFIG ;
installConfigFile( "stinger.new", "stinger.cfg" ) ;
}
sub getHttpSetup
{
my $refHash = $_[0] ;
my %httpSetup ;
$httpSetup{'httpPort80'} = 1 ;
$httpSetup{'httpsPort443'} = 1 ;
$httpSetup{'httpAltPort'} = 8080 ;
$httpSetup{'httpAltEnable'} = 0 ;
$httpSetup{'httpsAltPort'} = 8443 ;
$httpSetup{'httpsAltEnable'} = 0 ;
if ( open( HTTPPORTS, '/etc/sysconfig/httpPorts' ) )
{
while (<HTTPPORTS>)
{
my ($key, $value1, $value2) = split ;
$httpSetup{$key} = $value1 ;
if ($key eq 'httpAltPort' )
{
$httpSetup{ 'httpAltEnable' } = $value2 ;
}
else
{
$httpSetup{ 'httpsAltEnable' } = $value2 ;
}
}
close( HTTPPORTS ) ;
}
%{$refHash} = %httpSetup ;
}
sub saveHttpSetup
{
my %httpSetup = %{$_[0]} ;
open( HTTPPORTS, '>/tmp/httpPorts.new' ) ;
print HTTPPORTS
"httpPort80   $httpSetup{'httpPort80'}\n",
"httpsPort443 $httpSetup{'httpsPort443'}\n",
"httpAltPort  $httpSetup{'httpAltPort'} ",
"$httpSetup{'httpAltEnable'}\n",
"httpsAltPort $httpSetup{'httpsAltPort'} ",
"$httpSetup{'httpsAltEnable'}\n",
;
close( HTTPPORTS ) ;
installConfigFile( 'httpPorts.new', 'httpPorts' ) ;
if ( -r '/var/run/httpd.pid' )
{
my $pid = qx( cat /var/run/httpd.pid ) ;
system( "(sleep 4 ; /usr/bin/sudo /bin/kill $pid) &" ) ;
}
}
sub getIptablesSetup
{
my $refHash = $_[0] ;
my %iptablesSetup ;
$iptablesSetup{'enable'} = 0 ;
my @rangeBases ;
my @rangeBits ;
if ( open( IPTABLES, '/etc/sysconfig/iptables.conf' ) )
{
while (<IPTABLES>)
{
last if (/^\*filter/) ;
}
while (<IPTABLES>)
{
if ( /^:INPUT / )
{
my $enable = (split)[1] ;
$iptablesSetup{'enable'} = ($enable eq 'DROP') ? 1 : 0 ;
next ;
}
if ( /^-A INPUT / )
{
my $ipfield = (split)[3] ;
my $bits = 32 ;
if ( $ipfield =~ /\// )
{
($ipfield, $bits) = split( '/', $ipfield ) ;
if ($bits =~ /\./)
{
my @octet = split( '\.', $bits ) ;
$bits = 0 ;
FORLOOP:
for ( my $i = 0 ; $i < 4 ; ++$i )
{
my $j = 128 ;
while ($j != 0)
{
if ( ($octet[$i] & $j) == 0)
{
last FORLOOP ;
}
++$bits ;
$j = $j >> 1 ;
}
}
}
}
push( @rangeBases, $ipfield ) ;
push( @rangeBits, $bits ) ;
next ;
}
}
close( IPTABLES ) ;
}
$iptablesSetup{'rangeCount'} = (@rangeBases+0) ;
$iptablesSetup{'rangeBases'} = \@rangeBases ;
$iptablesSetup{'rangeBits' } = \@rangeBits ;
%{$refHash} = %iptablesSetup ;
}
sub saveIptablesSetup
{
my %iptablesSetup = %{$_[0]} ;
my $rangeCount = $iptablesSetup{'rangeCount'} ;
open( IPTABLES, '>/tmp/iptables.conf.new' ) ;
print IPTABLES "# Generated by setIptables.cgi, on ", qx(date) ;
print IPTABLES "*filter\n" ;
print IPTABLES ':INPUT ',
$iptablesSetup{'enable'} ? 'DROP' : 'ACCEPT',
"\n" ;
for ( my $i = 0 ; $i < $rangeCount ; ++$i )
{
print IPTABLES '-A INPUT -s ',
$iptablesSetup{'rangeBases'}[$i],
"/",
$iptablesSetup{'rangeBits'}[$i],
" -j ACCEPT\n" ;
}
print IPTABLES "COMMIT\n" ;
close( IPTABLES ) ;
installConfigFile( 'iptables.conf.new', 'iptables.conf' ) ;
system( '(sleep 2 ; /usr/bin/sudo /etc/init.d/iptables) &' ) ;
}
sub getAdvertiseControls
{
my $refHash = $_[0] ;
my %advertiseControls ;
$advertiseControls{'enable'} = 0 ;
$advertiseControls{'interval'} = 600 ;
$advertiseControls{'IPs'}    = [] ;
$advertiseControls{'ports'}  = [] ;
if ( open( ADVERTISE, '/etc/sysconfig/advertise' ) )
{
while (<ADVERTISE>)
{
my ($key, $value1, $value2) = split ;
if ($key eq 'Enable:')
{
$advertiseControls{'enable'} = 1 if ($value1 eq 'yes') ;
}
elsif ($key eq 'Interval:')
{
$advertiseControls{'interval'} = $value1 ;
}
else
{
push( @{$advertiseControls{'IPs'}}, $value1 ) ;
push( @{$advertiseControls{'ports'}}, $value2 ) ;
}
}
close( ADVERTISE ) ;
}
%{$refHash} = %advertiseControls ;
}
sub saveAdvertiseControls
{
my %advertiseControls = %{$_[0]} ;
my @ports = @{$advertiseControls{'ports'}} ;
my @IPs   = @{$advertiseControls{'IPs'}} ;
my $targetCount = scalar( @IPs ) ;
open( ADVERTISE, '>/tmp/advertise.new' ) ;
print ADVERTISE "Enable: ",
$advertiseControls{'enable'}
? "yes\n"
: "no\n" ;
print ADVERTISE "Interval: $advertiseControls{'interval'}\n" ;
for my $i (0..$#IPs)
{
print ADVERTISE "Target: ",
@{$advertiseControls{'IPs'}}[$i],
"  ",
@{$advertiseControls{'ports'}}[$i],
"\n" ;
}
close( ADVERTISE ) ;
installConfigFile( 'advertise.new', 'advertise' ) ;
if ( -e '/var/run/advertise.pid' )
{
my $pid = qx( cat /var/run/advertise.pid ) ;
system( "/usr/bin/sudo kill -SIGHUP $pid" ) ;
}
}
sub savePppDialoutControls
{
my %pppDialoutControls = %{$_[0]} ;
open( DIALOUT, '>/tmp/dialout.new' ) ;
if ( $pppDialoutControls{'papPw'} ne '' )
{
print DIALOUT "pappw: $pppDialoutControls{'papPw'}\n" ;
}
if ( $pppDialoutControls{'chapPw'} ne '' )
{
print DIALOUT "chappw: $pppDialoutControls{'chapPw'}\n" ;
}
my @lines = split( /\n/, $pppDialoutControls{'options'} ) ;
print DIALOUT "options: ", scalar(@lines), " lines\n" ;
foreach (@lines)
{
print DIALOUT "$_\n" ;
}
@lines = split( /\n/, $pppDialoutControls{'chatScript'} ) ;
print DIALOUT "\nchatScript: ", scalar(@lines), " lines\n" ;
foreach (@lines)
{
print DIALOUT "$_\n" ;
}
close( DIALOUT ) ;
installConfigFile( 'dialout.new', 'dialout' ) ;
my $pidFile = '/var/run/dialout.pid' ;
if ( -e $pidFile )
{
my $pid = qx( cat $pidFile ) ;
chomp $pid ;
system( "(/usr/bin/sudo kill $pid ;
sleep 3 ;
[[ -d /proc/$pid ]] && /usr/bin/sudo kill $pid ;
) &"
) ;
}
}
sub getPppDialoutControls
{
my $refHash = $_[0] ;
my %pppDialoutControls =
(
'papPw' => '' ,
'chapPw' => '' ,
'options' => '' ,
'chatScript' => '' ,
) ;
if ( open( DIALOUT, '/etc/sysconfig/dialout' ) )
{
while (<DIALOUT>)
{
if ( m/pappw:\s*(.*)/ )
{
$pppDialoutControls{'papPw'} = $1 ;
}
elsif ( m/chappw:\s*(.*)/ )
{
$pppDialoutControls{'chapPw'} = $1 ;
}
elsif ( m/options:\s*(\d+)/ )
{
my $count = $1 ;
my $options = '' ;
while ( $count-- > 0 )
{
my $line = <DIALOUT> ;
chomp $line ;
$options .= $line."\n" ;
}
$pppDialoutControls{'options'} = $options ;
}
elsif ( m/chatScript:\s*(\d+)/ )
{
my $count = $1 ;
my $chat = '' ;
while ( $count-- > 0 )
{
my $line = <DIALOUT> ;
chomp $line ;
$chat .= $line."\n" ;
}
$pppDialoutControls{'chatScript'} = $chat ;
}
}
close( DIALOUT ) ;
}
%{$refHash} = %pppDialoutControls ;
}
sub getVoltages
{
my ( $primaryV, $secondaryV, $temperature ) = (0,0,0);
if ( -x '/usr/local/fireball/voltage' )
{
open( VOLTS, '/usr/local/fireball/voltage -a |' ) ;
$primaryV = <VOLTS> ;
$secondaryV = <VOLTS> ;
$temperature = <VOLTS> ;
close VOLTS ;
$primaryV = (split( ' ', $primaryV ))[3] ;
$secondaryV = (split( ' ', $secondaryV ))[3] ;
$temperature = (split( ' ', $temperature ))[2] ;
}
return ($primaryV, $secondaryV, $temperature) ;
}
sub getVsleep
{
open( VSLEEP, '/etc/sysconfig/vsleep' ) ;
my $vsleep = <VSLEEP> ;
close( VSLEEP ) ;
return $vsleep ;
}
sub saveVsleep
{
open( VSLEEP, '>/tmp/vsleep.new' ) ;
printf VSLEEP "%.3f\n", $_[0] ;
close( VSLEEP ) ;
installConfigFile( 'vsleep.new', 'vsleep' ) ;
if ( -r '/var/run/frontpanel_task.pid' )
{
my $pid = qx( cat /var/run/frontpanel_task.pid ) ;
system( "/usr/bin/sudo /bin/kill -SIGINT $pid" ) ;
}
}
sub getAutoRebootLimit
{
my $configFile = '/etc/sysconfig/autoReboot' ;
my $autoRebootLimit = 0 ;
if ( -f $configFile )
{
$autoRebootLimit = qx( cat $configFile ) + 0 ;
}
return $autoRebootLimit ;
}
sub saveAutoRebootLimit
{
my $limit = int( $_[0] + 0.5 ) ;
if ($limit != 0 and $limit < 720)
{
$limit = 720 ;
}
if ($limit > 0xffffffff)
{
$limit = 0xffffffff ;
}
open( CFG, '>/tmp/autoReboot.new' ) ;
print CFG "$limit\n" ;
close( CFG ) ;
installConfigFile( 'autoReboot.new', 'autoReboot' ) ;
}
sub autoRebootReset
{
my $pid = qx( cat /var/run/frontpanel_task.pid ) ;
system( "/usr/bin/sudo /bin/kill -SIGWINCH $pid" ) ;
}
sub MakeConfigFile
{
my $fname = shift ;
$fname =~ s/[^\w\.]/_/g ;
my @filesToInclude = () ;
my %functions = () ;
foreach my $p (@_)
{
$p = lc( $p ) ;
$functions{$p} = 1 ;
}
if ( $functions{ 'ioconfig' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/gpssd.config' )  ;
push( @filesToInclude, '/etc/sysconfig/met.conf' )  ;
push( @filesToInclude, '/etc/sysconfig/advertise' )  ;
push( @filesToInclude, '/etc/sysconfig/dialout' )  ;
push( @filesToInclude,
'/etc/sysconfig/mgetty+sendfax/mgetty.config'
) ;
push( @filesToInclude, '/etc/sysconfig/ppp/options.console' )  ;
push( @filesToInclude, '/etc/sysconfig/ppp/options.tts.1' )  ;
push( @filesToInclude, '/etc/sysconfig/ppp/options.tts_max0' )  ;
push( @filesToInclude, '/etc/sysconfig/ppp/options.tts_max1' )  ;
}
if ( $functions{ 'refstation' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/ref_stn.config' )  ;
}
if ( $functions{ 'sessions' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/sessions' )  ;
push( @filesToInclude, '/etc/sysconfig/sleepmode' )  ;
push( @filesToInclude, '/etc/sysconfig/autoDelete' )  ;
}
if ( $functions{ 'stinger' }
|| $functions{ 'miscellaneous' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/stinger.cfg' )  ;
push( @filesToInclude, '/etc/sysconfig/vsleep' )  ;
push( @filesToInclude, '/etc/sysconfig/autoReboot' )  ;
}
if ( $functions{ 'extref' }
|| $functions{ 'extreference' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/extRefFreq' )  ;
}
if ( $functions{ 'ethernet' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/interfaces' )  ;
push( @filesToInclude, '/etc/sysconfig/resolv.conf' )  ;
}
if ( $functions{ 'ftp' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/ftp.conf' )  ;
}
if ( $functions{ 'ipfiltering' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/iptables.conf' )  ;
}
if ( $functions{ 'http' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/httpPorts' )  ;
}
if ( $functions{ 'ntp' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/ntp.conf' )  ;
push( @filesToInclude, '/etc/sysconfig/step-tickers' )  ;
}
if ( $functions{ 'security' }
|| $functions{ 'everything' }
)
{
push( @filesToInclude, '/etc/sysconfig/htaccess.fileaccess' )  ;
push( @filesToInclude, '/etc/sysconfig/htaccess.gpsadmin' )  ;
push( @filesToInclude, '/etc/sysconfig/htaccess.sysadmin' )  ;
push( @filesToInclude, '/etc/sysconfig/htgroups' )  ;
push( @filesToInclude, '/etc/sysconfig/htpasswd' )  ;
}
if ( $functions{ 'everything' } )
{
push( @filesToInclude, '/etc/sysconfig/sysname' )  ;
}
open NEWFILE, '>/tmp/newConfigFile' ;
print NEWFILE "# ++ FBCfg v1\n" ;
print NEWFILE "# Configuration File, Original Name = $fname\n" ;
print NEWFILE "# created ", qx( /bin/date ), "\n";
for my $cf (@filesToInclude)
{
if ( open CFILE, $cf )
{
print NEWFILE "\n## file $cf\n" ;
while (<CFILE>)
{
chomp ;
print NEWFILE $_, "\n" ;
}
close CFILE ;
print NEWFILE "## end of file $cf\n" ;
}
}
close NEWFILE ;
system(
"sudo cp /tmp/newConfigFile '/etc/sysconfig/configFiles/$fname'"
) ;
unlink( '/tmp/newConfigFile' ) ;
return  1 ;
}
1 ;
