#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Clock Steering Control',
'/clockSteeringInfo.html'
) ;
$_ = qx( /usr/local/fireball/sysinfo -p clock_steering ) ;
chomp ;
my (undef, undef, $CSstate) = split( " ", $_ ) ;
print startform( -name=>'theForm',
-action=>'/perl-scripts/gpsadmin/setClockSteering.cgi'
) ;
my @Control = radio_group( -name=>'clockSteering',
-value=>[ 'on', 'off' ],
-nolabels=>1,
-default=> $CSstate
) ;
print table( {border=>'1'},
Tr(
td( {width=>'30', align=>'center'}, $Control[0] ),
td( b('Enabled'),br(),
'Clock Steering will be used to reduce clock '.
'offset to near zero.'
)
),
Tr(
td( {align=>'center'}, $Control[1] ),
td( b('Disabled'),
br(),
'Clock Steering will not be used.  Clock bias on '.
'measurements and positions can be up to '.
'500 microseconds and will drift with time.'
)
)
) ;
print br(),hr() ;
print button( -name=>'OK',
-value=>'OK',
-onClick=>'parent.submitForm( document.theForm, "" )'
) ;
print '&nbsp;' ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/rconfigDisplay.cgi" )'
) ;
print endform() ;
print end_html() ;
