#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
startPage( 'File Delete' ) ;
my $Rootdir='/var/gps' ;
my $sortBy = param('sortBy') ;
if ( ! $sortBy )
{
$sortBy = 'name' ;
}
my $message = 'Missing parameter to deleteFile.cgi' ;
my $delay = 4000 ;
my $dirpath ;
my $file = param( 'delete' ) ;
if ( $file
&& $file !~ /\.\./
)
{
$dirpath = $file ;
$dirpath =~ s|/[^/]*$|/| ;
if ($file eq '/')
{
$message = "Can't delete '/' directory." ;
}
elsif ( $file =~ m|/$| )
{
$file =~ s|/$|| ;
if ( -l $Rootdir.$file )
{
$message = "Symlink $file has been deleted." ;
unlink( $Rootdir.$file ) ;
$delay = 0 ;
}
else
{
my $time = param('time') || 0 ;
open TS, ">/tmp/timestamp" ;
print TS "$time\n" ;
close( TS ) ;
utime $time, $time, "/tmp/timestamp" ;
system( "find $Rootdir$file -type f ! -name '*.A' ! -cnewer /tmp/timestamp -exec rm {} \\;" ) ;
unlink "/tmp/timestamp" ;
system( "find $Rootdir$file -depth -type d -exec rmdir {} \\;" ) ;
if ( -d "$Rootdir$file" )
{
$message = "Attempted to delete directory $file, but "
."active files prevented full deletion." ;
}
else
{
$message = "Directory $file has been deleted." ;
$delay = 0 ;
}
}
$dirpath =~ s|[^/]*/$|| ;
}
else
{
$message = "File $file has been deleted." ;
unlink $Rootdir.$file ;
$delay = 0 ;
}
}
if ($delay)
{
print h2( $message ) ;
}
my $URL = "/perl-scripts/dataFiles.cgi?dir="
.CGI::escape( $dirpath )
."&sort=$sortBy&msg="
.CGI::escape( $message ) ;
print <<EOF ;
<script>
parent.loadAfterDelay( "$URL", $delay ) ;
</script>
EOF
print end_html() ;
