#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'PPS (Pulse-Per-Second) Output',
'/ppsInfo.html'
) ;
my (undef, undef, $pps_enable, $pps_slope)
= split( " ",
qx( /usr/local/fireball/sysinfo -p pps_mode )
) ;
param( 'PpsEnable', ($pps_enable eq 'on' ? 'On' : 'Off' ) ) ;
print startform( -name=>'theForm',
-action=>'/perl-scripts/gpsadmin/setPps.cgi'
) ;
my @PPSControl = radio_group( -name=>'PpsEnable',
-value=>[ 'On', 'Off' ],
-nolabels=>1,
-default=>'On',
) ;
print table( {border=>'1'},
Tr(
td( {width=>'30', align=>'center'}, $PPSControl[0] ),
td( b('Enabled'),br(),
'A one pulse per second signal will be generated',
br(),
'with its positive edge aligned to UTC.'
)
),
Tr(
td( {align=>'center'}, $PPSControl[1] ),
td( b('Disabled'),
br(),
'No PPS signal will be generated.'
)
)
) ;
print br(), hr() ;
print button( -name=>'OK',
-value=>'OK',
-onClick=>'parent.submitForm( document.theForm, "" ) '
) ;
print '&nbsp;' ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>'parent.loadDataFrame(
"/perl-scripts/rconfigDisplay.cgi"
)'
) ;
print endform() ;
print end_html() ;
