#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
my $identityString= qx|cat /etc/sysconfig/sysname| ;
my $serialNumber = qx(/usr/bin/sudo /usr/local/fireball/warranty -s) ;
chomp $serialNumber ;
$serialNumber = (split("[ :]+",$serialNumber))[1] ;
titleWithHelp( 'Receiver Status - Identity',
'/identityInfo.html'
) ;
print <<EOF ;
<style type="text/css">
<!--
a {color:blue ; text-decoration: none }
-->
</style>
EOF
my $etherIP =
(split( ':',
(split( ' ',
qx( /sbin/ifconfig eth0 | grep 'inet addr:' ) ))[1]
))[1] ;
my $dnsname = "[No Name Server Defined]" ;
if (open( RESOLVE, "/etc/sysconfig/resolv.conf" ) )
{
for my $serverIP (grep(/^nameserver/, <RESOLVE>))
{
$serverIP =~ s/^nameserver\s+// ;
$dnsname = "[Name Server not responding]" ;
use IO::Socket::INET ;
my $s = IO::Socket::INET->new( PeerHost=>$serverIP,
PeerPort=>53,
Timeout=>4,
Proto=>'tcp'
) ;
if ( $s )
{
close( $s ) ;
my @dnsresults = split( "\n",
qx( /usr/bin/nslookup $etherIP $serverIP )
) ;
if ( (scalar(@dnsresults) == 5)
&& ($dnsresults[3] =~ /^Name:/)
)
{
$dnsname = ( split( ' ', $dnsresults[3] ) )[1] ;
}
else
{
$dnsname = "[Unknown]" ;
}
last ;
}
}
close( RESOLVE ) ;
}
my $fwVersion = 'Unknown' ;
my $fwDate    = '01-Jan-2000' ;
if ( -r '/usr/local/fireball/defaults/firmwareVersion' )
{
($fwVersion, $fwDate) = split( "\n",
qx( cat /usr/local/fireball/defaults/firmwareVersion )
) ;
my ($year,$month,$day) = split( '/', $fwDate ) ;
$fwDate = "$day $monthStrings[$month-1] $year" ;
}
print table( {border=>0, align=>'center'},
Tr( td( {align=>'right', width=>'25%'}, 'System Name: ' ),
td( {align=>'center'},
b($identityString)
),
td( {width=>'25%'},  '&nbsp;' )
),
Tr( td( {align=>'right'}, 'Serial Number: ' ),
td( {align=>'center'}, b($serialNumber) )
),
Tr( td( {align=>'right'}, 'Ethernet IP: ' ),
td( {align=>'center'}, b($etherIP) )
),
Tr( td( {align=>'right'}, 'DNS Resolved Name: ' ),
td( {align=>'center'}, b($dnsname) )
),
Tr( td( {align=>'right'}, 'Firmware Version: ' ),
td( {align=>'center'},
b( "$fwVersion&nbsp;&nbsp;&nbsp;$fwDate" )
) ,
),
Tr( td( '&nbsp;' ),
td( {align=>'center'},
table( {border=>2,align=>'center',cellpadding=>5},
Tr(
td( {align=>'center'},
a( {href=>
"javascript:parent.loadDataFrame('sysadmin/setSysname.cgi')"
},
'Set System Name'
)
),
)
)
)
)
) ;
print '<p>&nbsp;' x 3 ;
print <<EOF ;
&copy; 2003-2012, Trimble Navigation Limited. All rights reserved.
Trimble is a trademark of Trimble Navigation Limited registered in the
United States Patent and Trademark Office. The Globe &amp; Triangle logo
is a trademark of Trimble Navigation Limited.  All other trademarks are
the property of their respective owners.
EOF
if ( open( SLEEP, '/etc/sysconfig/sleepmode' ) )
{
$_ = <SLEEP> ;
close SLEEP ;
if ( m/^yes/)
{
print <<EOF ;
<hr />
<h2>Power Saving Mode Is Active!</h2>
This system will attempt to save battery power by shutting down between
data logging sessions.  This could happen at any time, depending on the
currently defined data logging schedule.
<p>
If you don't want to risk the system turning off during your browser
session, go to the
<a href="/perl-scripts/sleepMode.cgi">Power&nbsp;Saving&nbsp;control&nbsp;page</a> and
turn off the Power Saving mode.
<hr />
<script>
alert( 'Power Saving Mode is active.\\n' +
'Please read the warning on the Identity page.' ) ;
</script>
EOF
}
}
print end_html() ;
