#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
startPage( 'Set Access' ) ;
my $message = '' ;
my @levels = ( 'sysadmin', 'gpsadmin', 'fileaccess' ) ;
my %oldRestrictions ;
getGuiSecurity( \%oldRestrictions ) ;
my %newRestrictions ;
foreach my $r (@levels)
{
my $p = param( $r ) ;
$p = $newRestrictions{ $r } = (param( $r ) eq 'Restricted') ;
if ( $p != $oldRestrictions{$r} )
{
$message .= h4( 'Access is now ',
$p ? 'Restricted' : 'Unrestricted',
' for ',
($r eq 'sysadmin')
? 'System Controls'
: ($r eq 'gpsadmin')
? 'GPS Controls'
: 'File Access' ,
' pages.',
) ;
}
}
updateGuiSecurity( \%newRestrictions ) ;
if (! $message )
{
$message = h4('No changes were made.') ;
}
print <<EOF ;
<script>
document.location = '/perl-scripts/access.cgi?msg='
+ escape( '$message' ) ;
</script>
EOF
print end_html() ;
