#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
startPage( 'Set AutoReboot' ) ;
my $configFile = '/etc/sysconfig/autoReboot' ;
my $autoRebootLimit = 0 ;
if ( -f $configFile )
{
$autoRebootLimit = qx( cat $configFile ) ;
}
my $newAutoRebootLimit = 0 ;
if ( param( 'autoRebootEnable' ) )
{
$newAutoRebootLimit = param( 'autoRebootLimit' ) ;
}
if ( param( 'autoRebootReset' ) == 1 )
{
print( h2( 'Restarting AutoReboot timer.' ) ) ;
}
if ( $newAutoRebootLimit * 3600 != $autoRebootLimit)
{
print( h2( ($newAutoRebootLimit != 0 )
? "Setting limit to $newAutoRebootLimit hours"
: "Disabling AutoReboot."
)
) ;
saveAutoRebootLimit( $newAutoRebootLimit * 3600 ) ;
}
autoRebootReset() ;
print <<EOF;
<Script>
parent.loadAfterDelay( 'rconfigDisplay.cgi', 1000) ;
</Script>
EOF
print end_html() ;
