#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
startPage( 'Set Client Authentication Key' ) ;
print h2( "Client Authentication Key" ) ;
my $errorMessage ;
my $key1 = param( 'key1' ) ;
my $key2 = param( 'key2' ) ;
$key1 =~ s/^\s+// ;
$key2 =~ s/^\s+// ;
$key1 =~ s/\s+$// ;
$key2 =~ s/\s+$// ;
if ($key1 !~ /\S{7}/)
{
$errorMessage = "Key must be seven non-space characters" ;
goto ERROR ;
}
if ($key1 ne $key2)
{
$errorMessage = "Second Key entry must match first." ;
goto ERROR ;
}
my $code = qx( /usr/local/fireball/makeKey $key1 ) ;
chomp $code ;
print h2( 'New Client Authentication key Accepted.' ) ;
my %allPortData ;
getPortSetup( \%allPortData ) ;
$allPortData{'AuthKey'} = $code ;
saveGpssdConfig( \%allPortData ) ;
print <<EOF ;
<Script>
parent.loadAfterDelay( "/perl-scripts/portSummary.cgi", 2000) ;
</Script>
EOF
goto EXIT ;
ERROR:
print h3( $errorMessage ) ;
print <<EOF ;
<Script>
alert( "$errorMessage" ) ;
parent.loadAfterDelay( "/perl-scripts/clientAuth.cgi", 1000) ;
</Script>
EOF
EXIT:
print end_html() ;
