#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
startPage( 'Set NTP' ) ;
my $errorMessage ;
my @servers = () ;
for (my $i = 0 ; $i < 3 ; ++$i)
{
my $server = param( 'server'.$i ) ;
$server =~ s/^\s*// ;
$server =~ s/\s*$// ;
next if ($server eq "") ;
if ($server =~ m/^[\-a-zA-Z0-9.]*$/)
{
push @servers, ($server) ;
}
else
{
$errorMessage = 'Illegal Characters in External Time Servers' ;
goto ERROR ;
}
}
print h2( 'New NTP setup accepted.' ) ;
print h2( 'Restarting NTP daemon.' ) ;
saveNtpServers( @servers ) ;
print <<EOF ;
<Script>
parent.loadAfterDelay( "/perl-scripts/rstatusIdentity.cgi", 2000) ;
</Script>
EOF
goto EXIT ;
ERROR:
print h3( $errorMessage ) ;
my $returnURL = '/perl-scripts/ntp.cgi'
. '?server0='.CGI::escape( param('server0') )
. '&server1='.CGI::escape( param('server1') )
. '&server2='.CGI::escape( param('server2') )
;
if ( defined( param('ntpDisable') ) )
{
$returnURL .= '&ntpDisable='.CGI::escape( param('ntpDisable') ) ;
}
$returnURL .= '&msg='.CGI::escape( $errorMessage ) ;
print <<EOF ;
<Script>
parent.loadAfterDelay( "$returnURL", 4000) ;
</Script>
EOF
EXIT:
print end_html() ;
