#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use IO::Socket;
use Fireball ;
titleWithHelp( 'Stinger Commands',
'' # No Help
) ;
my $command = '' ;
if (param())
{
$command = param('Command') ;
}
print startform( -name=>"theForm" ) ;
print textfield( 'Command', 'get pos_info', 80, 80 ) ;
print "<BR>" ;
print scrolling_list( -name=>'choices',
-values=>['Select Command',
'*get all_config',
'*get pos_info',
'*get tracking_status',
'*get gps_hlth',
'*get utc_data',
'*get iono_data',
'*get agc',
'get alm_data 1',
'get eph_data 1',
'*get pdop_mask',
'put pdop_mask 7',
'*get pps_mode',
'put pps_mode on pos',
'*get event_mode',
'put event_mode on pos',
'*get l2_mode',
'*put l2_mode enigma',
'*put l2_mode l2c_or_enigma',
'*put l2_mode l2c_and_enigma',
'*put l2_mode off',
'*get waas_mode',
'*put waas_mode on',
'*put waas_mode off',
'*get waas_hlth',
'*get waas_sv_masks',
'put waas_sv_masks E E E E E E E E E E E E E E E E E E E',
'*get elev_mask',
'put elev_mask 10',
'*get pos_rate',
'put pos_rate 10',
'*get meas_rate',
'put meas_rate 10',
'*get sv_masks',
'put sv_masks E E E E E E E E E E E E E E E E E E E E E E E E E E E E E E E E',
'*get clock_steering',
'put clock_steering on',
'*get everest',
'put everest on',
],
-size=>1,
-default=>'Select Command',
-onChange=>'newCommand()'
) ;
print <<endOfScripts ;
<Script>
/**********************************************************************/
function newCommand()
/**********************************************************************/
/* When a choice is made via the popup menus, this function is called.
* A new URL is loaded of the states of the popups, to request the
* specified data.
*/
{
index = document.theForm.choices.selectedIndex  ;
option = document.theForm.choices.options[index].value  ;
if (option == 'Select Command') return ;
//alert( "Choice:" + option ) ;
if (option.charAt(0) == '*')
{
document.theForm.Command.value = option.substring(1) ;
option = document.theForm.submit() ;
}
else
{
document.theForm.Command.value = option ;
}
} /* end of newCommand() */
</SCRIPT>
endOfScripts
print p(),submit( -name=>"Send", -value=>"Send" ) ;
print endform() ;
if ($command)
{
print p(),"Command sent was <b> $command </b>" ;
my $socketName = ($command =~ 'get ')
? '/var/stinger/info'
: '/var/stinger/config' ;
my $sun = sockaddr_un($socketName)|| die "no info";
socket(SOCK, PF_UNIX, SOCK_STREAM, PF_UNSPEC)|| die "socket: $!";
connect(SOCK,$sun)|| die "connect: $!";
SOCK->autoflush(1);
print (SOCK "$command\n") ;
print '<PRE>' ;
do {
$_ = <SOCK> ; print $_ ;
} while ($_ !~ "OK" && $_ !~ "^ERROR" ) ;
print  '</PRE>' ;
close( SOCK ) ;
}
print hr() ;
print timestamp() ;
print end_html() ;
