#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Sysinfo',
'' # No Help
) ;
my $command = '' ;
if (param())
{
$command = param('Command') ;
}
my @sysinfoFileIDs = ( 'ps', 'top' ) ;
if (open( SYSINFO, '/usr/local/fireball/sysinfo |' ) )
{
while (<SYSINFO> !~ /^  File ID/){} ;
$_ = <SYSINFO> ;
while (<SYSINFO>)
{
(my $fileID, undef) = split ;
$fileID .= ' 1' if ( $fileID =~ m/eph_data|alm_data|app_version/) ;
push( @sysinfoFileIDs, $fileID ) ;
}
close( SYSINFO ) ;
}
print startform( -name=>"theForm" ) ;
print submit( -name=>"Send", -value=>"Send" ) ;
print textfield( 'Command', 'ps', 80, 80 ) ;
print "<BR>" ;
print scrolling_list( -name=>'choices',
-values=>\@sysinfoFileIDs,
-size=>1,
-onChange=>'newCommand()'
) ;
print <<endOfScripts ;
<Script>
/**********************************************************************/
function newCommand()
/**********************************************************************/
/* When a choice is made via the popup menus, this function is called.
* A new URL is loaded of the states of the popups, to request the
* specified data.
*/
{
index = document.theForm.choices.selectedIndex  ;
option = document.theForm.choices.options[index].value  ;
document.theForm.Command.value = option ;
document.theForm.submit() ;
} /* end of newCommand() */
</SCRIPT>
endOfScripts
print endform() ;
if ( $command
and $command !~ /[^\w\ ]/
)
{
if ($command eq "ps")
{
$command =~ '/bin/ps' ;
}
elsif ($command eq "top")
{
$command = '/usr/bin/top -b -n 1 | cat' ;
}
else
{
$command =~ s/[;`'"*\$&|()]//g ;
$command = "/usr/local/fireball/sysinfo -p $command" ;
}
print '<pre>' ;
if ( open( SYSINFO, "$command |") )
{
while (<SYSINFO>)
{
print $_ ;
}
close( SYSINFO ) ;
}
print '</pre>' ;
}
print hr() ;
print timestamp() ;
print end_html() ;
