#!/usr/bin/perl -w
use CGI qw/:standard/;
use strict ;
use Fireball ;
titleWithHelp( 'Firmware Warranty Date',
'/warranty.html'
) ;
my $error = "" ;
my $action = "" ;
if (param())
{
if ( my $newSerialNumber = param("serialNumber") )
{
if ($newSerialNumber !~ /^\d{10}$/ )
{
$error = "Serial number must have 10 digits" ;
goto paramDone ;
}
$action = "New Serial Number is: $newSerialNumber<br />" ;
system( "/usr/bin/sudo /usr/local/fireball/warranty -p"
. $newSerialNumber ) ;
my $sysname = qx( cat /etc/sysconfig/sysname ) ;
chomp $sysname ;
if ($sysname eq 'RS0000000000')
{
$sysname = sprintf( 'RS%010d', $newSerialNumber ) ;
open SYSNAME, '>/tmp/sysname' ;
print SYSNAME "$sysname\n" ;
close SYSNAME ;
system( 'sudo cp /tmp/sysname /etc/sysconfig/sysname' ) ;
system( "sudo /bin/hostname $sysname" ) ;
}
}
if ( my $warrantyCode = param( "warrantyCode" ) )
{
if ($warrantyCode !~ /^\w{16}$/ )
{
$error = "Warranty code must have 16 digits" ;
goto paramDone ;
}
my $result = system( "/usr/bin/sudo /usr/local/fireball/warranty -f"
. $warrantyCode ) ;
if ($result == 0)
{
$action .= "Warranty Code accepted.<br />" ;
}
else
{
$error = "Invalid Warranty code." ;
}
}
}
paramDone:  # This is the exit point if parameter processing was
my $serialNumber = qx(/usr/bin/sudo /usr/local/fireball/warranty -s) ;
chomp $serialNumber ;
$serialNumber = (split("[ :]+",$serialNumber))[1] ;
print <<EOF ;
<script>
parent.updateSerialNumber( "$serialNumber" ) ;
</script>
EOF
my $warrantyDate = qx(/usr/bin/sudo /usr/local/fireball/warranty -w) ;
chomp $warrantyDate ;
$warrantyDate = (split("[ :]+",$warrantyDate))[2] ;
if ($warrantyDate != 0)
{
my ($month,$day,$year) = ($warrantyDate =~ /(..)(..)(....)/) ;
$month = $monthStrings[ $month-1 ] ;
$warrantyDate = "$day $month $year" ;
}
else
{
$warrantyDate = "none" ;
}
print startform( -name=>"theForm" ) ;
print '<table border="0">' ;
print Tr( td( {align=>'right'}, "Serial Number:" ),
th( $serialNumber )
) ;
print Tr( td( {align=>'right'}, "Current Warranty Date:" ),
th( $warrantyDate )
) ;
if ( $serialNumber == 0 )
{
print Tr( td( {-align=>'right'}, 'New Serial Number:' ),
td( {-align=>'left'},
textfield( 'serialNumber', '', 16, 10 )
)
) ;
}
print Tr( td( {-align=>'right'}, 'New Warranty Code:' ),
td( {-align=>'left'},
textfield( 'warrantyCode', '', 16, 16 )
)
) ;
print Tr( td( '' ),
td(
button( -name=>'OK',
-value=>'OK',
-onClick=> 'parent.submitForm( document.theForm,
"/perl-scripts/warranty.cgi" )'
),
button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/firmware.cgi" )'
)
)
) ;
print "</table>" ;
print endform() ;
if ( $error )
{
print << "EOF" ;
<Script>
alert( "$error" ) ;
</Script>
EOF
print "$error" ;
}
if ( $action )
{
print $action ;
}
print end_html() ;
