#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'L2 Tracking Control',
'/L2TrackingInfo.html'
) ;
$_ = qx( /usr/local/fireball/sysinfo -p l2_mode ) ;
chomp ;
my (undef, undef, $L2mode) = split( " ", $_ ) ;
print startform( -name=>'theForm',
-action=>'/perl-scripts/gpsadmin/setL2Tracking.cgi'
) ;
my @Control = radio_group( -name=>'L2Tracking',
-value=>[ 'off',
'enigma',
'l2c_or_enigma',
'l2c_and_enigma',
],
-nolabels=>1,
-default=> $L2mode
) ;
print table( {border=>'1'},
Tr(
td( {width=>'30', align=>'center'}, $Control[0] ),
td( b('Off'),br(),
'No L2 Signals will be tracked.'
)
),
Tr(
td( {width=>'30', align=>'center'}, $Control[1] ),
td( b('L2-Y-code Only'),br(),
'Y-code on L2 will be tracked.'
)
),
Tr(
td( {width=>'30', align=>'center'}, $Control[2] ),
td( b('L2C or L2-Y-code'),
br(),
'L2C will be tracked if available.',
br(),
'L2-Y-code will be tracked if L2C is not available.'
)
),
Tr(
td( {align=>'center'}, $Control[3] ),
td( b('L2C and L2-Y-code'),
br(),
'Both signals will be tracked simultaneously.'
)
)
) ;
print br(),hr() ;
print button( -name=>'OK',
-value=>'OK',
-onClick=>'parent.submitForm( document.theForm, "" )'
) ;
print '&nbsp;' ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/rconfigDisplay.cgi" )'
) ;
print endform() ;
print end_html() ;
