#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Security - Access Controls',
'/securityAccess.html'
) ;
if ( my $msg = param( 'msg' ) )
{
print $msg ;
}
my @levels = ( 'sysadmin', 'gpsadmin', 'fileaccess' ) ;
my %restrictions ;
getGuiSecurity( \%restrictions ) ;
print startform( -name=>'theForm',
-action=>'/perl-scripts/sysadmin/setAccess.cgi',
-onSubmit=>'return Okay();'
) ;
print b('System Controls') ;
my @buttons=radio_group( -name=>'sysadmin',
-values=>['Restricted','Open'],
-nolabels=>1,
-default=>($restrictions{'sysadmin'}
?'Restricted' : 'Open'
),
) ;
print table( {width=>'100%', border=>1},
Tr( td( $buttons[0] ),
td( '<b>Restricted</b><BR>
Only selected accounts, using the proper
passwords, can modify Accounts and Basic Receiver
Configuration.'
)
) ,
Tr( td( $buttons[1]),
td( '<b>Unrestricted</b> ' )
)
) ;
print br() ;
print b('GPS Controls') ;
@buttons=radio_group( -name=>'gpsadmin',
-values=>['Restricted','Open'],
-nolabels=>1,
-default=>($restrictions{'gpsadmin'}
?'Restricted' : 'Open'
),
) ;
print table( {width=>"100%", border=>1},
Tr( td( $buttons[0] ),
td( '<b>Restricted</b><BR>
Only selected accounts, using the proper
passwords, can modify GPS tracking and Data
logging controls.'
)
) ,
Tr( td( $buttons[1]),
td( '<b>Unrestricted</b> ' )
)
) ;
print br() ;
print b("File Access") ;
@buttons=radio_group( -name=>'fileaccess',
-values=>['Restricted','Open'],
-nolabels=>1,
-default=>($restrictions{'fileaccess'}
?'Restricted' : 'Open'
),
) ;
print table( {width=>'100%', border=>1},
Tr( td( $buttons[0] ),
td( "<b>Restricted</b><BR>
Only selected accounts, using the proper
passwords, can access logged data files via the
browser interface."
)
) ,
Tr( td( $buttons[1]),
td( "<b>Unrestricted</b> " )
)
) ;
print p(),button( -name=>'OK',
-value=>'OK',
-onClick=>'Okay()'
) ;
print <<EOF ;
<script>
function Okay()
/* Submit the form's data.  If the user is switching on sysadmin
* security then we ask for confirmation.  If he doesn't know
* the root password then he's locking himself out.
* The test for this is three OR clauses.
* Only submit the form If
*     Sysadmin Unrestricted is checked.
*  or The Sysadmin Restricted was originally checked.
*  or the User responds OK to the confirmation request.
*/
{
f = document.theForm ;
if ( f.sysadmin[1].checked
|| f.sysadmin[0].defaultChecked
|| confirm( 'This cannot be undone without a Sysadmin password\\n'
+ 'Are you sure?'
)
)
{
parent.submitForm( f, '' ) ;
}
return false ;
}
</script>
EOF
print '&nbsp;' ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/rstatusIdentity.cgi" )'
) ;
print endform() ;
print end_html() ;
