#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Configuration Files',
'/configFiles.html'
) ;
print <<EOF ;
<style type="text/css">
<!--
a {color:blue ; text-decoration: none }
-->
</style>
EOF
if (my $msg = param('message'))
{
print h4( $msg ) ;
}
else
{
print h4( '&nbsp;' ) ;
}
chdir '/etc/sysconfig/configFiles' ;
my @allfiles = glob '*' ;
if (@allfiles)
{
print '<Table border align="center">' ;
print Tr( th( ['File','Apply','Download','Delete'] ) ) ;
for my $f (@allfiles)
{
my $ef = CGI::escape($f) ;
$f =~ s/ /&nbsp;/g ;
print Tr(
td( '&nbsp;',
a( {href=>"configFiles.cgi?show=$ef"},
$f
),
'&nbsp;'
),
td(  {align=>'center'},
a( {href=>"javascript:Apply('$f')"},
img( { src=>'/images/bluedot.gif',
border=>'0',
alt=>'Apply'
}
)
)
),
td(  {align=>'center'},
a( {href=>"/configDownload/$ef"},
img( { src=>'/images/bluedot.gif',
border=>'0',
alt=>'Download'
}
)
)
),
td(  {align=>'center'},
a( {href=>"javascript:Delete('$f')"},
img( { src=>'/images/redX.gif',
border=>'0',
alt=>'Delete'
}
)
)
),
) ;
}
print '</Table>' ;
}
else
{
print 'There are no Configuration Files available.', hr() ;
}
print <<EOF ;
<script>
/**********************************************************************/
function Apply( filename )
/**********************************************************************/
{
if (confirm( 'Apply settings in configuration file "'
+ filename
+ '"?'
+ "\\nThis will restart your NetRS!"
)
)
{
parent.loadDataFrame(
'/perl-scripts/sysadmin/configApply.cgi?apply='
+ escape( filename )
) ;
}
} /* end of Apply() */
/**********************************************************************/
function Delete( filename )
/**********************************************************************/
{
if (confirm( 'Delete configuration file "'
+ filename
+ '"?'
)
)
{
parent.loadDataFrame(
'/perl-scripts/sysadmin/configDelete.cgi?delete='
+ escape( filename )
) ;
}
} /* end of Delete() */
</script>
EOF
print br(),br() ;
print table(
{border=>2,align=>'center'},
Tr(
td( {align=>'center', width=>"33%" },
a( {href=>"configCreate.cgi?startcreate=yes"} ,
"Create New<br />&nbsp;Configuration&nbsp;File&nbsp;"
)
),
td( {align=>'center', width=>"34%" },
a( {href=>"configUpload.cgi?upload=start"} ,
"Upload<br />&nbsp;Configuration&nbsp;File&nbsp;"
)
),
)
) ;
my $fname ;
if ( ($fname = param('show'))
&& $fname !~ /[^\w.]/
)
{
print hr(), "Configuration File \"$fname\"", p() ;
open FILE, "/etc/sysconfig/configFiles/$fname" ;
print '<PRE>' ;
print <FILE> ;
print '</PRE>' ;
close FILE ;
}
print end_html() ;
