#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
startPage( 'Set External Reference' ) ;
my $setting = qx( cat /etc/sysconfig/extRefFreq ) ;
$setting = ( $setting =~ m/External/ )
? 'enabled'
: 'disabled'
;
my (undef, $detected) = split( ',',
qx(/usr/local/fireball/extfreq -p)
) ;
$detected = ($detected =~ m/present/)
? 'present'
: 'not detected'
;
my $newsource = param('refsource') ;
if ( $newsource =~ m/External|Internal/ )
{
if ( ($newsource eq 'External') xor ($setting eq 'enabled') )
{
open( NEWCONFIG, '>/tmp/extRefFreq' ) ;
print NEWCONFIG "REFSOURCE=", $newsource, "\n" ;
close NEWCONFIG ;
system( 'sudo cp /tmp/extRefFreq /etc/sysconfig/extRefFreq' ) ;
system( 'sudo /usr/local/fireball/sysinfo -m'  ) ;
print h2("Switching to $newsource source for reference frequency."),
h3( 'Restarting signal tracking.' ),
h3( 'It may take several minutes to resume normal operation.')
;
print <<EOF ;
<Script>
parent.loadAfterDelay( '/perl-scripts/rconfigDisplay.cgi',
2000) ;
</Script>
EOF
}
else
{
print h2( "No Change Made to External Reference Frequency Source!" ) ;
print <<EOF ;
<Script>
parent.loadAfterDelay( '/perl-scripts/rconfigDisplay.cgi',
1000) ;
</Script>
EOF
}
}
print end_html() ;
