#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'NTP Client Configuration', '/ntpInfo.html') ;
my @servers = () ;
if (!param() )
{
param( 'ntpDisable', '1' ) ;
@servers = getNtpServers() ;
param( 'ntpDisable', '0' ) if (@servers) ;
}
if (param('msg'))
{
print h3( param( 'msg' ) ) ;
}
print startform( -name=>'theForm',
-action=>'/perl-scripts/sysadmin/setNtp.cgi'
) ;
print b( 'External Time Servers:' ) ;
print "<Table>" ;
for (my $i = 0 ; $i < 3 ; ++$i)
{
print Tr( td( {width=>"40"}, "" ),
td( textfield( -name=>'server'.$i,
-default=>$servers[$i],
-size=>30,
-maxlength=>100,
-onChange=>'enableNTP();',
)
)
) ;
}
print Tr( td( {align=>'right'},
checkbox( -name=>'ntpDisable',
-value=>'1',
-label=>'',
-onclick=>'disableNTP();'
)
),
td( 'Disable using NTP time servers.' )
) ;
print "</Table>" ;
print <<EOF ;
<script>
function disableNTP()
/* Called when the ntpDisable checkbox is clicked.  If the box is
* checked, then we need to clear out the text fields showing the
* NTP time servers.
*/
{
if (document.theForm.ntpDisable.checked)
{
document.theForm.server2.value = '' ;
document.theForm.server1.value = '' ;
document.theForm.server0.value = '' ;
}
} // end of disableNTP()
function enableNTP()
/* Called when the server text fields are modified.  This is the
* inverse operation of disableNTP().  The idea is that if you enter
* an NTP time server, the Disable box will clear.  Note that this
* will only occur if the text fields are modified and the focus is
* then shifted to another form element.
*/
{
document.theForm.ntpDisable.checked = false ;
} // end of disableNTP()
</script>
EOF
print p(),button( -name=>'OK',
-value=>'OK',
-onClick=>'parent.submitForm( document.theForm, "" )'
) ;
print "&nbsp;" ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>'parent.loadDataFrame(
"/perl-scripts/internetEthernet.cgi" )'
) ;
print endform() ;
print end_html() ;
