#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Satellites - GPS Enable/Disable',
'/satEnaDisInfo.html'
) ;
$_ = qx( /usr/local/fireball/sysinfo -p sv_masks ) ;
my @state = split( " ", $_ ) ;
splice( @state, 0, 2 ) ;
for ( my $i = 1 ; $i < 33 ; ++$i )
{
param( 'Enable'.$i,
($state[$i-1] ne 'D') ? 1 : 0
) ;
param( 'Ignore'.$i,
($state[$i-1] eq 'I') ? 1 : 0
) ;
}
print startform( -name=>'theForm',
-action=>'/perl-scripts/gpsadmin/setEnaDis.cgi'
) ;
print '<table border="0">' ;
print th( "PRN" ),
th( "&nbsp;&nbsp;Enable&nbsp;&nbsp;" ),
th( "Ignore<br />Health" ),
th( "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" ),
th( "PRN" ),
th( "&nbsp;&nbsp;Enable&nbsp;&nbsp;" ),
th( "Ignore<br />Health" ),
th( "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" ),
th( "PRN" ),
th( "&nbsp;&nbsp;Enable&nbsp;&nbsp;" ),
th( "Ignore<br />Health" ),
;
for ( my $i = 0 ; $i < 11 ; ++$i )
{
print "<tr>" ;
for my $prn ( $i+1, $i+12, $i+23 )
{
last if ($prn > 32) ;
print td( {align=>'center'},$prn )  ;
print td( {align=>'center'},
checkbox( -name=>"Enable$prn",
-value=>'1',
-label=>'',
-onClick=>"enClick($prn)"
)
) ;
print td( {align=>'center'},
checkbox( -name=>"Ignore$prn",
-value=>'1',
-label=>'',
-onClick=>"igClick($prn)"
)
) ;
print td() ;
}
print "</tr>" ;
}
print '</table>' ;
print hr() ;
print button( -name=>'OK',
-value=>'OK',
-onClick=>'parent.submitForm( document.theForm, "" )'
) ;
print '&nbsp;' ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>'parent.loadDataFrame(
"/perl-scripts/satGeneral.cgi" ) '
) ;
print '&nbsp;' ;
print button( -name=>'EnableAll',
-value=>'Enable All',
-onClick=>"enableAll();"
) ;
print endform() ;
print <<EOF ;
<Script>
/**********************************************************************/
function igClick( prn )
/**********************************************************************/
/* Called when an ignore checkbox is clicked, with the prn number as
* a parameter.  If the Ignore button is being enabled, we automatically
* click the matching Enabled button as well.
*/
{
en = document.theForm[ "Enable" + prn ] ;
ig = document.theForm[ "Ignore" + prn ] ;
if (ig.checked)
en.checked = true ;
} /* end of Update() */
/**********************************************************************/
function enClick( prn )
/**********************************************************************/
/* Called when an Enable checkbox is clicked, with the prn number as
* a parameter.  If the Enable button is being disabled, we automatically
* uncheck the matching IgnoreHealth button as well.
*/
{
en = document.theForm[ "Enable" + prn ] ;
ig = document.theForm[ "Ignore" + prn ] ;
if (! en.checked)
ig.checked = false ;
} /* end of Update() */
/**********************************************************************/
function enableAll()
/**********************************************************************/
/* Called when the Enable All button is clicked.
* Modifies all of the checkboxes to the Enabled state.
*/
{
for (prn = 1 ; prn < 33 ; ++prn )
{
document.theForm[ "Enable" + prn ].checked = true ;
}
} /* end of Update() */
</Script>
EOF
print end_html() ;
