#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
titleWithHelp( 'Firmware Upload',
'/firmwareUpload.html'
) ;
my $firmwareDir = '/var/gps' ;
chdir $firmwareDir ;
print <<EOF ;
<Script>
/**********************************************************************/
function upload()
/**********************************************************************/
{
//alert( "submit" ) ;
document.theForm.submit() ;
} /* end of Update() */
</Script>
EOF
my $errorMessage = '' ;
my $testResults  = '' ;
if (param())
{
my $fname = upload( 'firmwareFile' ) ;
my $tmpfilename = tmpFileName($fname) ;
my $size = (-s $tmpfilename) ;
if ($size)
{
my $newFname = $fname ;
$newFname =~ s/^.*\\// ;
$newFname =~ s/^.*\/// ;
my $newPath = '/var/gps/incoming/'.$newFname ;
if ( ! -d '/var/gps/incoming' )
{
mkdir '/var/gps/incoming' ;
}
if ( ! -w '/var/gps/incoming' )
{
system( '/usr/bin/sudo chown netrx:netrx /var/gps/incoming' ) ;
system( '/usr/bin/sudo chmod a+rw /var/gps/incoming' ) ;
}
rename $tmpfilename, $newPath ;
system( "chmod a+rx $newPath" ) ;
close( $fname ) ;
print '<br /><b>Upload complete.</b><br />',
'<b>Verifying RPM package.</b>' ;
my $url = '/perl-scripts/sysadmin/firmwareVerify.cgi?fname='
. CGI::escape( $newFname ) ;
print <<EOF;
<Script>
parent.loadAfterDelay( "$url", 1000) ;
</Script>
EOF
print end_html() ;
goto EXIT ;
}
else
{
$errorMessage = "There was a problem uploading file '$fname'" ;
}
}
print start_multipart_form( -name=>'theForm' ) ;
print "File to Upload ",
filefield( -name=>'firmwareFile',
-size=>60
) ;
print hr() ;
print button( -name=>'Upload',
-value=>'Upload',
-onClick=>'upload() ;',
) ;
print '&nbsp;' ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/firmware.cgi" )'
) ;
print end_form() ;
my($availSpace) = ( split " ", qx( df /var/gps ) )[10] ;
print <<EOF ;
Firmware files are uploaded to the target system's data logging area.
There must be sufficient empty space in that area to contain the entire
firmware file.  Please verify that the size of the file you are about to
upload is less than the available space listed below.  If not, then you
will need to delete one or more logged data files before starting the
upload.  You might also be able to reclaim space by deleting any old
firmware files that you no longer need.
<br /><br />
<b>Space available for uploaded firmware files:</b>
EOF
printf( "%.3f Mbytes<br />", $availSpace/1024 ) ;
if ($errorMessage)
{
print <<EOF ;
<Script>
alert( "$errorMessage" ) ;
</Script>
EOF
print "<br /><b>$errorMessage</b>" ;
if ($testResults)
{
print "<br />RPM test results:<pre>$testResults</pre>" ;
}
}
EXIT:
print end_html() ;
