#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
titleWithHelp( 'Upload Firmware File',
'/firmwareUpload.html'
) ;
my $errorMessage = '' ;
my $testResults  = '' ;
my $fname = param('fname') ;
print b( "Verifying file $fname<br />" ) ;
my $firmwareDir = '/var/gps/incoming' ;
chdir $firmwareDir ;
if (! -r $fname)
{
$errorMessage = "Can't find file $fname." ;
goto ERROR ;
}
$testResults  = RpmVerify( $fname, 1 ) ;
if ($testResults eq '')
{
print b('Verified successfully.') ;
print <<EOF;
<br />Switching to Firmware Status Page
<Script>
parent.loadAfterDelay( "firmware.cgi", 3000) ;
</Script>
EOF
goto EXIT ;
}
else
{
$errorMessage = "There is a problem with file '$fname'" ;
}
ERROR:
if ($errorMessage)
{
print <<EOF ;
<Script>
alert( "$errorMessage" ) ;
</Script>
EOF
print "<br /><b>$errorMessage</b>" ;
if ($testResults)
{
print "<br />Test results:<pre>$testResults</pre>" ;
}
print startform( -name=>"theForm" ) ;
print button( -name=>'Done',
-value=>'Done',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/firmware.cgi" )'
) ;
print endform() ;
}
EXIT:
print end_html() ;
