#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib ".." ;
use Fireball ;
titleWithHelp( 'Set System Name', '/rxstatSysName.html' ) ;
my $error="" ;
if (param())
{
my $newname = param( "Sysname" ) ;
if (! $newname )
{
$error="A System Name must be specified!" ;
goto paramDone ;
}
$newname =~ s/ /_/g ;
if ( $newname =~ /[^A-Za-z0-9_-]/ )
{
$error='Invalid Characters in System Name!\n'.
'Use only A to Z, a to z, 0 to 9, - and _' ;
goto paramDone ;
}
open SYSNAME, '>/tmp/sysname' ;
print SYSNAME "$newname\n" ;
close SYSNAME ;
system( 'sudo cp /tmp/sysname /etc/sysconfig/sysname' ) ;
system( "sudo /bin/hostname $newname" ) ;
print h1("System Name Change Accepted.") ;
print <<EOF ;
Switching to Identity Information display.
<script>
parent.updateSysname( "$newname" ) ;
parent.loadAfterDelay( "/perl-scripts/rstatusIdentity.cgi", 1000) ;
</script>
EOF
print end_html() ;
goto EXIT ;
}
paramDone:  # jump to here if parameter processing terminates early.
print startform( {name=>"theForm"} ) ;
my $sysname = qx( cat /etc/sysconfig/sysname ) ;
print '<Table align=center width=100% >' ;
print Tr( th( {-align=>'right'}, 'System Name' ),
td( textfield( 'Sysname', $sysname, 12, 12 ) )
) ;
print Tr(
td( {align=>'right'},
button( -name=>"OK",
-value=>"OK",
-onClick=>
'parent.submitForm( document.theForm,
"/perl-scripts/sysadmin/setSysname.cgi" )'
)
),
td( button( -name=>"cancel", -value=>"Cancel",
-onClick=>
'parent.loadDataFrame( "/perl-scripts/rstatusIdentity.cgi" )'
)
)
) ;
print "\n</Table>\n</Form>\n" ;
if ( length $error )
{
print "<Script>
alert( \"$error\" ) ;
</Script>
" ;
$error =~ s/\\n/<BR>/g ;
print "$error" ;
}
print end_html() ;
EXIT:
